; Draw the background

Draw_Background:dec b cs:Rand_W		; Move the waterfalls

		mov ds,cs:Buff_Seg	; Point at the buffer

		mov es,cs:Block_Defns	; Point at the sprites

		; Setup the background ptr

		mov al,b cs:Screen_Y	; Get the Y
		and ax,0007h		; Mask

		add ax,ax		; * 16
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		neg ax			;

		add ax,o Pal_LU_B+8*16	; The X/Y-Ref
		mov cs:Pal_Ref,ax	;

		; Now, calc the ptr to the map

		mov ax,cs:Screen_X	; Get the X

		shr ax,1		; /16
		shr ax,1		;
		shr ax,1		;
		and ax,0FFFEh		;

		mov si,o Map		; Point at the map
		add si,ax		; Add the offset

		mov ax,cs:Screen_Y	; Get the Y
		and ax,0FFF0h		; Mask lower 16 offset

		add ax,ax		; * 128/16
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		add si,ax		; Merge

		; Now, calc the ptr to the display

		mov ax,cs:Screen_X	; Get the X
		and ax,000Fh		; 0 .. 15

		mov bx,Buff_Offset	; Point at the appropriate byte
		sub bx,ax		; Align		

		mov ax,cs:Screen_Y	; Get the Y
		and ax,000Fh		; 0 .. 15
		mov dx,0		;

		mov cx,X_Step		; * this
		mul cx			;

		sub bx,ax		; Merge
		mov dx,bx		; Save in dx

		; Now setup the counts

		mov ch,View_Height_P + 1; No of cells down
		mov cl,View_Width_P + 1	; Across

		; Now, we must draw the background for each cell requiring it

		mov bp,o Raised_Ptrs	; Raised data

DF_Y_Lp:	mov bx,o Blank_Ptrs	; Blank data
		mov di,o Block_Ptrs	; Block data

		; Now, scan the line

DF_X_Lp:	mov ax,cs:[si]		; Get the next cell
		inc si			; Skip
		inc si			;

		cmp al,030h		; Background/Wall ?
		jae DF_Backgnd		; Backgnd or Raised

		; Just foreground, nothing else

DF_Fore:	mov cs:[di],dx		; Save the address
		inc di			; Skip
		inc di			;
		mov cs:[di],ax		; Save the data
		inc di			;
		inc di			;

		; Next tile

		add dx,16		; Skip tile

		dec cl			; Loop in X
		jnz DF_X_Lp		;

		; Now, we must show this line

DF_Show:	mov ax,0		; Terminate the lists
		mov cs:[bx],ax		;
		mov cs:[di],ax		;

		; Save the ptrs

		push si			; Save
		push dx			;
		push cx			;
		push bp			;

		; Any blanks ?

		mov di,o Blank_Ptrs	; Point at the list

		mov bx,cs:[di]		; Any ?
		cmp bx,0		;
		jne DFS_Blanks		; Yes, show them

DF_BlanksDone:	mov di,o Block_Ptrs	; Point at the list

		mov bx,cs:[di]		; Any ?
		cmp bx,0		;
		je DF_BlocksDone	; No, skip

		cmp bx,Buff_End		; End ?
		jae DF_BlocksDone	; Yes, skip

		jmp DFS_Blocks		; Show them

DF_BlocksDone:	pop bp			; Restore
		pop cx			;
		pop dx			;
		pop si			;

		; Done, move down

		mov cl,View_Width_P + 1	; Count across

		add dx,16*X_Step - (View_Width_P+1)*16 ; Move to the next char row

		lea si,(128-(View_Width_P+1))*2[si]	; Move the ptr to the map

		cmp si,o Map + 128*64*2
		jae DF_X

		dec ch			; Loop
		jnz DF_Y_Lp		;

		; Terminate the raised list

DF_X:		mov w cs:[bp],0		; End it

		ret			; Done

	; A Combined tile, or a background tile

DF_BackGnd:	test al,80h		; Raised ?
		jnz DF_Raised		; Yes, skip

		; Not raised, drive it here

		mov cs:[bx],dx		; Save the ptr
		inc bx			;
		inc bx			;

		; Does this have a foreground char ?

		cmp al,030h		; Backdrop only ?
		jne DF_Fore		; No, save foreground

		; Next tile

		add dx,16		; Skip tile

		dec cl			; Loop in X
		jz DF_Show		; No

		jmp DF_X_Lp		; Yes

	; This is a raised tile, add it to the raised-list

DF_Raised:	and al,7Fh		; Lose the raised bit

		cmp al,030h		; Background as well ?
		jb DFR_1		; No, skip

		; Save the background ptr

		mov cs:[bx],dx		; Save the ptr
		inc bx			;
		inc bx			;

		je DFR_Next		; Background only, skip

		; Now store the raised bit

		mov cs:[bp],dx		; Save the address
		mov cs:2[bp],ax		; Save the data
		lea bp,4[bp]		;

		; Next tile

DFR_Next:	add dx,16		; Skip tile

		dec cl			; Loop in X
		jz DF_Show		; No

		jmp DF_X_Lp		; Yes

	; Raised foreground, nothing else

DFR_1:		mov cs:[bp],dx		; Save the address
		mov cs:2[bp],ax		; Save the data
		lea bp,4[bp]		;

		jmp s DFR_Next		; Skip this tile

; Show the blank tiles, bx = display posn, di = list

DFS_Blanks:	mov al,bl		; Get the ptr
		and ax,07h		; Get the X posn.

		add ax,cs:Pal_Ref	; Index into the palette
		mov si,ax		;

		; Now, fill the list of blocks

		mov cl,16		; 16 lines

		mov w cs:Y_Off,0	; Offset := 0

DFSB_Lp:	push di			; Save the ptrs

		mov eax,cs:[si]		; Read it
		mov edx,cs:4[si]	; Read it

		; Now write them

		mov bx,cs:[di]		; Get the ptr

DFSB_Next_B:	add bx,cs:Y_Off		; Add the offset
		mov ds:[bx],eax		;
		mov ds:4[bx],edx	;

		mov ds:8[bx],eax	; Write it
		mov ds:12[bx],edx	; Write it

		; Now, is there another block ?

		inc di			; Skip
		inc di			;

		mov bx,cs:[di]		; End ?/Offset

		cmp bx,0		;
		jne DFSB_Next_B		; Next line

		; End of line, get the next palette

		pop di			; Restore

		; Next palette

		lea si,16[si]		; Move down

		; Move down

		mov ax,X_Step		; Down
		add cs:Y_Off,ax		;

		dec cl			; Loop
		jnz DFSB_Lp		;

		jmp DF_BlanksDone	; Loop

; This cell is full, draw into it bx = pDisp

		align 16

DFS_NextBlock:	mov di,bp		; Get the ptr

DFS_Blocks:	inc di			; Skip the addr
		inc di			;

		mov ax,cs:[di]		; Get the shape

		lea bp,2[di]		; Save the ptr

		; Draw the block

		cmp al,2Ch		; Water ?
		je DF_Water		;

		cmp al,38h		; Water top ?
		je DF_WaterT		;

DFW_1:		call Draw_Block		; Draw it

		; Now, we see if there were any blocks to draw

DFSB_Next:	mov bx,cs:[bp]		; Next

		cmp bx,0		; Any ?
		jnz DFS_NextBlock	; Yes, loop

		jmp DF_BlocksDone	; Done

	; Draw a water block

DF_Water:	mov al,cs:Rand_W
		shr al,1
		and al,3
		add al,2Ch

		jmp s DFW_1

	; Draw a water top block

DF_WaterT:	mov ax,cs:Cheap_Rand
		xor ax,bx
		xor ax,di
		xor ax,bp

		and al,1
		add al,38h

		jmp s DFW_1

; Show the raised tiles

Draw_Raised:	mov di,o Raised_Ptrs	; Point at the list

		mov bx,cs:[di]		; Any ?
		cmp bx,0		;
		je DR_X			; No, skip

		cmp bx,Buff_End		; End ?
		jae DR_X		; Yes, skip

		jmp s DR_Blocks		; Draw them

; This cell is full, draw into it bx = pDisp

		align 4

DR_NextBlock:	mov di,bp		; Get the ptr

DR_Blocks:	inc di			; Skip the addr
		inc di			;

		mov ax,cs:[di]		; Get the shape

		lea bp,2[di]		; Save the ptr

		; Draw the block

		cmp al,2Ch		; Water ?
		je DR_Water		;

DRW_1:		call Draw_Block		; Draw it

		; Now, we see if there were any blocks to draw

DRB_Next:	mov bx,cs:[bp]		; Next

		cmp bx,0		; Any ?
		jnz DR_NextBlock	; Yes, loop

DR_X:		ret			; Done

	; Draw a water block

DR_Water:	mov al,cs:Rand_W
		shr al,1
		and al,3
		add al,2Ch

		jmp s DRW_1


; Now draw block al at bx

Draw_Block:	and al,7Fh		; Make it valid

		; We have to draw this, setup the RETF

		pop di			; Giz the return address
		push cs			; Save the seg
		push di			; Save the offset

		; We now have a far-return

		mov ah,0		; 16-bit
		add ax,ax		;
		mov di,ax		; Point into the table

		mov ax,cs:Sprite_Ptrs[di]; Get the segment offset
		add ax,cs:Sprite_F_Base	; Index into the code
		push ax			;

		push w 0		; IP

		; We can now start the sprite-code with a RETF

		mov di,bx		; Into DI

		; Start the code

		retf			; "CALL" the sprite

DB_X:		ret			; Fail, exit

; Create the foreground

Create_Map:	mov cx,128*64		; Map length
		mov di,o Map		; Map base

CM_Lp:		push di			; Save
		push cx			;

		call Rand_32		; Random

		pop cx			; Restore
		pop di			;

		and ax,000Fh		; 0 or 1
		mov cs:[di],ax		; Set it

		add di,2		; Skip

		loop CM_Lp		; Loop

		ret			; Done

; Fixed data
; This is used to fill blocks

		align 4

Pal_LU_B	db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h
		db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h

		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h

		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h

		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h

		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh
		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh

		db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h
		db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h

		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h

		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h

		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h

		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh
		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh

		db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h
		db 0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h

		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		db 0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh
		
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h
		db 0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h

		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		db 0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh
		
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h
		db 0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h

		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		db 0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh
		
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h
		db 0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h

		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh
		db 0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh

		; Foreground

		db 080h,081h,082h,083h,084h,085h,086h,087h
		db 080h,081h,082h,083h,084h,085h,086h,087h

		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		
		db 090h,091h,092h,093h,094h,095h,096h,097h
		db 090h,091h,092h,093h,094h,095h,096h,097h

		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h

		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h

		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh
		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh

		db 080h,081h,082h,083h,084h,085h,086h,087h
		db 080h,081h,082h,083h,084h,085h,086h,087h

		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		
		db 090h,091h,092h,093h,094h,095h,096h,097h
		db 090h,091h,092h,093h,094h,095h,096h,097h

		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h

		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h

		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh
		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh

		db 080h,081h,082h,083h,084h,085h,086h,087h
		db 080h,081h,082h,083h,084h,085h,086h,087h

		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		db 088h,089h,08Ah,08Bh,08Ch,08Dh,08Eh,08Fh
		
		db 090h,091h,092h,093h,094h,095h,096h,097h
		db 090h,091h,092h,093h,094h,095h,096h,097h

		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		db 098h,099h,09Ah,09Bh,09Ch,09Dh,09Eh,09Fh
		
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h
		db 0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h

		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		db 0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh
		
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h
		db 0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h

		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh
		db 0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh

; Vars

		align 2

Pal_Ref		dw ?			; The Y-colour

Y_Off		dw ?			; The offset down a block

Blank_Ptrs	dw 20 dup (?)		; The blank cells
Block_Ptrs	dw 20*2 dup (?)		; The block cells

Raised_Ptrs	dw 2*(View_Width_P+1)*(View_Height_P+1)+1 dup (?)	; Raised cells

Rand_W		db ?			; Water random
