; This code drives the weapons about

spWeapL		equ iBlobs		; The first weapon sprite no.
spWeapM		equ iBlobs + 1		; Smaller
spWeapS		equ iBlobs + 2		; Smaller still

; Init fire

Init_Fire:	mov b cs:Fire_Rate,0	; Slow
		mov b cs:Fire_Type,1	; Balls

		ret			; Done

; Improve the fire-rate

Imp_Fire_Rate:	mov al,cs:Fire_Rate	; Get it
		cmp al,3		; Max ?
		je IFR_X		; Yes, skip

		inc al			; Step it

IFR_X:		mov cs:Fire_Rate,al	; Store it
		ret			; Done

; Improve the fire-type

Imp_Fire_Type:	mov al,cs:Fire_Type	; Get it
		cmp al,3		; Max ?
		je IFT_X		; Yes, skip

		inc al			; Step it

IFT_X:		mov cs:Fire_Type,al	; Store it
		ret			; Done


; See if the player wants to fire

Player_Fire:	call far ptr Test_Fire	; Fire ?
		jz PF_NF		; No, exit

		; We wish to fire, dec the count

		dec b cs:PF_Wait	; Dec the delay
		jz PF_Fire		; Yes, skip

		ret			; Done

	; Fire something

PF_Fire:	mov b cs:PF_Wait,5	; The fire-rate

		mov dl,cs:Fire_Type	; Type
		mov dh,cs:Fire_Rate	; Count

		; Point at the appropriate vectors

		mov al,cs:Play_F_Vect	; Point at the table for this dirn.
		cbw			;

		add ax,ax		; * 6
		mov bp,ax		;

		add ax,ax		;
		add bp,ax		;

		add bp,o Fire_Vectors	;

		; Move the fire start to allow for movement

		call Get_Player_Sq	; Get the squashed amount, if any
		mov cs:Player_Squash,ah	; Set the new value

		cbw			;
		add ax,cs:Player_Y	; Move Y
		mov bx,ax		; Save the Y

		mov ax,cs:Player_X	; Get X

		call Try_To_Fire	; Fire summat
		jc PF_NF		; Failed, reset the count

		ret			; Done

	; Reset the fire-count

PF_NF:		mov b cs:PF_Wait,1	; Set the delay
		ret			; Done

; Fire given parameters

Try_To_Fire:	mov cs:TTF_X,ax		; Save the X/Y
		mov cs:TTF_Y,bx		;

		; Limit the degree-count to 3 (0,1,2,3)

		cmp dh,3		; 0 .. 3
		jbe TTF_1		; Yes, skip

		mov dh,3		; Clip to 3

TTF_1:		mov bl,dh		; Ptr := 0 .. 3
		mov bh,0		;

		; Mask the weapon-type to 0 .. 3

		and dl,03h		; 0 .. 3
		add dl,dl		; * 4
		add dl,dl		;

		or bl,dl		; bx = WWDD

		add bx,bx		; * 2
		add bx,o Wep_pTab	; Index into the array

		mov si,cs:[bx]		; Point at the defn. of this weapon

		; Now, create the bits of this weapon

TTF_Lp:		call TTF_Inner		; Create one
		jc vTTF_Fail		; Failed, exit

		lea si,wtLength[si]	; Skip the entry

		test w cs:wtpCode[si],-1; Another ?
		jnz TTF_Lp		; Yes, loop

		clc			; Ok		
		ret			; Done

vTTF_Fail:	jmp TTF_Fail		; Vector

	; Now, create a 'sprite'

TTF_Inner:	call Get_Free		; Giz some free space
		jc vTTF_Fail		; Can't, exit

		call Add_Proj		; Add it as a projectile

		; Get the vector

		mov bx,cs:4[bp]		; Point at the vectors
		add bx,cs:wtVect[si]	; dX

		; Save the X/Y

		mov ax,cs:TTF_X		; X
		add ax,cs:[bp]		; X-Offset
		mov cs:d_X[di],ax	;

		mov ax,cs:TTF_Y		; Y
		add ax,cs:2[bp]		; Y-Offset
		mov cs:d_Y[di],ax	;

		; Clear misc vars

		mov al,0		; 00
		mov cs:d_frac_X[di],al	;
		mov cs:d_frac_Y[di],al	;

		mov al,cs:wtState[si]	; Get the state
		mov cs:dState[di],al	;

		mov al,cs:wtShape[si]	; Get the shape
		mov cs:dShape[di],al	;

		mov ax,cs:wtpCode[si]	; Get the routine
		mov cs:dpMove[di],ax	;

		mov ax,cs:wtLife[si]	; Get the lifetime
		mov cs:dLife[di],ax	;

		mov al,cs:wtSize[si]	; Get the size
		mov cs:dcStep[di],al	;

		mov ax,cs:[bx]		; dX
		add ax,cs:Player_dX	; Player move
		add ax,cs:Plat_dX	; Plus the platform dX
		mov cs:ddX[di],ax	; dX

		mov ax,cs:2[bx]		; dY
		add ax,cs:Player_dY	;
		add ax,cs:Plat_dY	; Plus the platform dY
		mov cs:ddY[di],ax	;

		; Pre-move

		push bx			; Save

		mov bx,cs:ddY[di]	; Move it in Y
		mov al,bh		; Make 24-bit
		cbw			;

		sub cs:d_frac_Y[di],bl	; Step it
		sbb cs:d_Y[di],ax	;

		mov bx,cs:ddX[di]	; Move it in X
		mov al,bh		; Make 24-bit
		cbw			;

		sub cs:d_frac_X[di],bl	; Step it
		sbb cs:d_X[di],ax	;

		pop bx			; Restore

		clc			; Ok
		ret			;

TTF_Fail:	stc			; Fail
		ret			;

; Code to move all the weapons

Drive_Weapons:	mov di,cs:pProjs	; Point at the proj list

		cmp di,0		; Any projectiles ?
		jz DW_X			; No, exit

		mov ax,o pProjs-dpNext	; Point at this ptr
		mov cs:pPrev_Proj,ax	; Save this

		; There are projectiles

DW_Lp:		cmp di,0		; Valid ?
		jz DW_X			; No, skip

		; Dec it's life-time

		dec w cs:dLife[di]	; Decay it
		jz DW_End_TO		; Kill it

		; Now show this projectile

		mov bx,cs:dpMove[di]	; Point at it's code
		call bx			; Move it
		jc DW_End		; Kill it, (explode)

		; Move onto the next

DW_Next:	mov cs:pPrev_Proj,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next proj

		jmp DW_Lp		; Loop

	; Exit code, setup the un-draw operation

DW_X:		ret			; Done

	; We must kill this projectile

DW_End:		mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Proj	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s DW_Lp		; Loop

	; Time it out

DW_End_TO:	mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Proj	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s DW_Lp		; Loop

; Code to move the laser,entry with di pointing at data

Move_Laser:	mov al,cs:dcStep[di]	; Get the size
		cbw			;
		mov si,ax		; Into cx

		mov bx,cs:ddX[di]	; Move it in X
		mov al,bh		; Make 24-bit
		cbw			;

		add cs:d_frac_X[di],bl	; Step it
		adc ax,cs:d_X[di]	;
		mov cs:d_X[di],ax	;

		sub ax,si		; LHS
		mov cx,ax		; Save the X

		add ax,si		; RHS
		add ax,si		;
		mov dx,ax		;

		; Move in Y

		mov bx,cs:ddY[di]	; Move it in Y
		mov al,bh		; Make 24-bit
		cbw			;

		add cs:d_frac_Y[di],bl	; Step it
		adc ax,cs:d_Y[di]	;
		mov cs:d_Y[di],ax	;

		sub ax,si		; Top
		mov cs:Clip_Top,ax	;

		add ax,si		; Bottom
		add ax,si		;
		mov cs:Clip_Bott,ax	;

		; Is this capable of inflicting damage ?

		cmp si,0		; Size = 0
		jz ML_Show		; Yes, skip

		; Now, look down the list of things, checking for a hit

		mov si,cs:pThings	; Point at them

ML_Check_Lp:	cmp si,0		; Any ?
		jz ML_Show		; No, exit

		; Check if a hit here, first try the X . . .

		mov ax,cs:dLeft[si]	; Get the object LHS

		cmp ax,dx		; To the left ?
		ja ML_NoHit		; Yes, skip

		mov ax,cs:dRight[si]	; RHS
		cmp ax,cx		; To the right ?
		jb ML_NoHit		; Yes

		; The X is in range, now try the Y

		mov ax,cs:dTop[si]	; Get the object Top

		cmp ax,cs:Clip_Bott	; Below ?
		ja ML_NoHit		; Yes, skip

		mov ax,cs:dBott[si]	; Bottom

		cmp ax,cs:Clip_Top	; Above ?
		jb ML_NoHit		; Yes

		; Assume a hit

		mov ax,1		; Score one
		call Add_Score		;

		; Kill the weapon as far as damage is concerned

		mov b cs:dcStep[di],0	; Kill it

		; Explode it

		mov ax,15
		mov bx,cs:d_X[si]
		mov dx,cs:d_Y[si]
		sub dx,10
		mov cx,o Move_Expl
		call Create_Fizzle

		; Kill the thing

		dec b cs:dHits[si]	; Dead ?
		jne ML_NoHit		; No, skip

		mov w cs:dpMove[si],o MT_Suicide	; Kill it

		; Check the next thing

ML_NoHit:	mov si,cs:dpNext[si]	; Get the next one
		jmp s ML_Check_Lp	; Loop

 	; Show this projectile

ML_Show:	mov al,cs:dShape[di]	; Sprite

		cmp al,0		; Any ?
		jnz ML_Shape		; Yes, skip

		mov bl,cs:dState[di]	; State
		shr bl,1
		inc b cs:dState[di]	; Step it

		and bx,15		; 0 .. 15

		add bx,o Expl_Tab	; Expl
		mov al,cs:[bx]		;

ML_Shape:	mov ah,0		; Make the sprite number 16-bit

		mov bx,cs:d_X[di]	; X
		mov dx,cs:d_Y[di]	; Y

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			;

		cmp al,0		; Drawn ?
		jz ME_Fail		; No, skip

		clc			; OK
		ret			; Done/Not shown

ME_Fail:	stc			; Fail
		ret			;

; Vars

; Fixed data

		align 2

Wep_pTab	dw Wep_00,Wep_01,Wep_02,Wep_03	; Laser
		dw Wep_10,Wep_11,Wep_12,Wep_13	; Multi
		dw Wep_00,Wep_00,Wep_00,Wep_00	; ??
		dw Wep_00,Wep_00,Wep_00,Wep_00	; ??

; Definition of lasers

wtpCode		equ 0;1			; Ptr to driver code

wtVect		equ 2;3			; X Velocity

wtShape		equ 4			; Shape
wtState		equ 5			; Initial state

wtLife		equ 6;7			; Life (in frames)

wtSize		equ 8			; Size (in pixels)

wtLength	equ 9			; This many

; Vectors

; Man fire in various directions

Fire_Vectors	dw  20,-18,FV_R		; R	Horiz
		dw -20,-18,FV_L		; L
		dw  20,-26,FV_R		; RU	Jump
		dw -20,-26,FV_L		; LU
		dw  22,-29,FV_R		; RU	Jump1
		dw -22,-29,FV_L		; LU

		dw  19,-18,FV_R		; RD	Fall
		dw -19,-18,FV_L		; LD
		dw  11,-18,FV_R		; RD	Fall2
		dw -11,-18,FV_L		; LD

; Horiz

fv1		equ 150*3/2
fv2		equ 256*3/2
fv3		equ 300*3/2
fv5		equ 512*3/2
fv6		equ 600*3/2
fv7		equ 768*3/2
fv8		equ 800*3/2
fv10		equ 1024*3/2
fv12		equ 1280*3/2
fv15		equ 1536*3/2

FV_L		dw -fv7,0		; dX,dY
		dw -fv10,0		;
		dw -fv12,0		;
		dw -fv15,0		;

		dw -fv7,-fv2		;
		dw -fv7,fv2		;

		dw -fv5,-fv5		;
		dw -fv5,fv5		;

		dw -fv8,-fv1		;
		dw -fv8,fv1		;

		dw -fv6,-fv3		;
		dw -fv6,fv3		;

FV_R		dw fv7,0		; dX,dY
		dw fv10,0		;
		dw fv12,0		;
		dw fv15,0		;

		dw fv7,-fv2		;
		dw fv7,fv2		;

		dw fv5,-fv5		;
		dw fv5,fv5		;

		dw fv8,-fv1		;
		dw fv8,fv1		;

		dw fv6,-fv3		;
		dw fv6,fv3		;

; 00

Wep_00		dw Move_Laser		; Laser
		dw 0*4			; Vect
		db spWeapS		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 3			; Size

		dw 0			; EOL

		; 01

Wep_01		dw Move_Laser		; Laser
		dw 1*4			; Vect
		db spWeapS		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 3			; Size

		dw 0			; EOL

		; 02

Wep_02		dw Move_Laser		; Laser
		dw 2*4			; Vect
		db spWeapM		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 4			; Size

		dw 0			; EOL

		; 03

Wep_03		dw Move_Laser		; Laser
		dw 3*4			; Vect
		db spWeapL		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 5			; Size

		dw 0			; EOL

		; 10

Wep_10		dw Move_Laser		; Laser
		dw 0*4			; Long
		db 0;spWeapS		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 8			; Size

		dw 0			; EOL

Wep_11		dw Move_Laser		; Laser
		dw 1*4			; Vect
		db 0;spWeapM		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 8			; Size

		dw Move_Laser		;
		dw 4*4			;
		db 0;spWeapS		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 5*4			;
		db 0;spWeapS		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw 0			; EOL

Wep_12		dw Move_Laser		; Laser
		dw 1*4			; Vect
		db 0;spWeapL		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 8			; Size

		dw Move_Laser		;
		dw 4*4			;
		db 0;spWeapM		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 5*4			;
		db 0;spWeapM		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 6*4			;
		db 0;spWeapS		;
		db 0			;
		dw 20			;
		db 8			; Size

		dw Move_Laser		;
		dw 7*4			;
		db 0;spWeapS		;
		db 0			;
		dw 20			;
		db 8			; Size

		dw 0			; EOL

Wep_13		dw Move_Laser		; Laser
		dw 1*4			; Vect
		db 0;spWeapL		; Shape
		db 0			; State = 0
		dw 30			; Lifetime
		db 8			; Size

		dw Move_Laser		;
		dw 8*4			;
		db 0;spWeapM		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 9*4			;
		db 0;spWeapM		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 10*4			;
		db 0;spWeapS		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw Move_Laser		;
		dw 11*4			;
		db 0;spWeapS		;
		db 0			;
		dw 30			;
		db 8			; Size

		dw 0			; EOL

; Explosion table

Expl_Tab	db iFire		; 0
		db iFire+1		; 1
		db iFire+2		; 2
		db iFire+3		; 3
		db iFire+4		; 4
		db iFire+5		; 5
		db iFire+6		; 6
		db iFire+7		; 7
		db iFire+8		; 8
		db iFire+9		; 9
		db iFire+10		; 10
		db iFire+11		; 11
		db iFire+12		; 12
		db iFire+13		; 13
		db iFire+13		; 14
		db iFire+13		; 15
		db iFire+13		; 16
		db iFire+13		; 17
		db iFire+13		; 18
		db iFire+13		; 19
		db iFire+13		; 20
		db iFire+13		; 21
		db iFire+13		; 22
		db iFire+13		; 23
		db iFire+13		; 24
		db iFire+13		; 25
		db iFire+13		; 26
		db iFire+13		; 27
		db iFire+13		; 28
		db iFire+13		; 29
		db iFire+13		; 30
		db iFire+13		; 31


; Vars

		align 2			; Even

pPrev_Proj	dw ?			; Ptr to the last ptr

TTF_X		dw ?			; The firer's X
TTF_Y		dw ?			; and Y

Clip_Top	dw ?			; Top of weapon
Clip_Bott	dw ?			; Bottom

PF_Wait		db ?			; Time to fire again

Fire_Rate	db ?			; Type of weapon
Fire_Type	db ?			; Rate of fire
