; This code drives the fizzles (small explosions) and smears about

; Now, create a 'fizzle' code at cx, life ax, posn bx:dx

Create_Fizzle:	push di			; Save
		push ax			; Save

		call Get_Free		; Giz some free space
		jc CFZ_Fail		; Can't, exit

		call Add_Fizzle		; Add it as a fizzle

		; Setup the move routine

		mov cs:dpMove[di],cx	;

		; Save the X/Y

		mov cs:d_X[di],bx	; X
		mov cs:d_Y[di],dx	; Y

		mov b cs:d_frac_X[di],0	;
		mov b cs:d_frac_Y[di],0	;

		mov w cs:ddX[di],0	; Velocity := 0
		mov w cs:ddY[di],0	; Velocity := 0

		; Clear misc vars

		mov b cs:dState[di],0	; State = 0

		pop ax			; Restore
		mov cs:dLife[di],ax	; Lifetime

		clc			; Ok
		pop di			;
		ret			;

CFZ_Fail:	stc			; Fail
		pop ax			;
		pop di			;
		ret			;

; Code to move all the fizzles

Show_Fizzles:	mov di,cs:pFizzles	; Point at the fizzle list

		cmp di,0		; Any fizzles ?
		jz SF_X			; No, exit

		mov ax,o pFizzles-dpNext; Point at this ptr
		mov cs:pPrev_Fizzle,ax	; Save this

		; There are fizzles

SF_Lp:		cmp di,0		; Valid ?
		jz SF_X			; No, skip

		; Dec it's life-time

		dec w cs:dLife[di]	; Decay it
		jz SF_End_TO		; Kill it

		; Now show this fizzle

		mov bx,cs:dpMove[di]	; Point at it's code
		call bx			; Move it
		jc SF_End		; Kill it, (explode)

		; Move onto the next

SF_Next:	mov cs:pPrev_Fizzle,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next fizzle

		jmp s SF_Lp		; Loop

	; Exit code, setup the un-draw operation

SF_X:		ret			; Done

	; We must kill this fizzle

SF_End:		mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Fizzle	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s SF_Lp		; Loop

	; Time it out

SF_End_TO:	mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Fizzle	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s SF_Lp		; Loop

Frict:		mov dx,ax		; Save

		mov cl,5		;
		sar dx,cl		;

		sub ax,dx		;
		ret			; Done

; Code to move the fizzle,entry with di pointing at data

Move_Fizzle:	mov dx,di		; Get ptr

		mov ax,cs:d_X[di]	; Calc vector
		sub ax,cs:Player_X	;
		add al,dl
		add ax,cs:ddX[di]	;

		call Frict		; Damp it

		mov cs:ddX[di],ax	;
		mov bx,ax		;

		mov ax,cs:d_Y[di]	; Calc vector
		sub ax,cs:Player_Y	;
		add al,dh
		add ax,70		; Offset to middle
		add ax,cs:ddY[di]	;

		call Frict		; Damp it

		mov cs:ddY[di],ax	;

		; Move it

MF_Move:	mov bx,cs:ddX[di]	; Get dY

		mov al,bh		; Make 24-bit
		cbw			;

		sub cs:d_frac_X[di],bl	; Step it
		sbb cs:d_X[di],ax	;

		mov bx,cs:ddY[di]	; Move it in Y

		mov al,bh		; Make 24-bit
		cbw			;

		sub cs:d_frac_Y[di],bl	; Step it
		sbb cs:d_Y[di],ax	;

		; Calc sprite

		mov bl,cs:dState[di]	; State
		shr bl,1
		inc b cs:dState[di]	; Step it

		and bx,15		; 0 .. 15

		add bx,o Impl_Tab	; Expl
		mov al,cs:[bx]		;

		mov ah,0		; Make the sprite number 16-bit

		mov bx,cs:d_X[di]	; X
		mov dx,cs:d_Y[di]	; Y

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			;

		cmp al,0		; Drawn ?
		jz MFZ_Fail		; No, skip

		clc			; OK
		ret			; Done/Not shown

MFZ_Fail:	stc			; Fail
		ret			;

; Code to move an explosion,entry with di pointing at data

Move_Expl:	mov ax,cs:Cheap_Rand	; Random

		mov bl,ah		; Save
		cbw			; +/-1
		add cs:ddX[di],ax	; Random X

		mov al,bl		; Save
		cbw			; +/-1
		add ax,30
		add cs:ddY[di],ax	; Random X

		jmp s MF_Move		; As above

; Fixed data

;Impl_Tab
;		db iExpl		; 
;		db iExpl+1		; 
;		db iExpl+2		; 
;		db iExpl+3		;
;		db iExpl+4		;

Impl_Tab	db iExpl		; 6
		db iExpl		; 7
		db iExpl		; 8
		db iExpl+2		; 9
		db iExpl+4		; 10
		db iExpl+6		; 11
		db iExpl+8		; 12
		db iExpl+10		; 13
		db iExpl+11		; 14
		db iExpl+12		; 15
		db iExpl+6		; 0
		db iExpl+5		; 1
		db iExpl+4		; 2
		db iExpl+3		; 3
		db iExpl+2		; 4
		db iExpl+1		; 5

; Vars

pPrev_Fizzle	dw ?			; Temp ptr
