; This is the monster driving source

; Offsets, used for all things

nSpace		equ 100			; This many

dpNext		equ 0;1			; Ptr to the next item

dFlags		equ 2			; 0 = Alive
					; 1 = On a platform

	; The order of these is important !!

d_frac_Y	equ 3			; fractional Y
d_Y		equ 4;5			; Y pos

dState		equ 6			; What we are doing . . .

d_frac_X	equ 7			; fractional X
d_X		equ 8;9			; X pos

	; Not any more

ddX		equ 10;11		; dX
ddY		equ 12;13		; dY
dImpact		equ 14;15		; dY on landing/takeoff
dPlat_X		equ 16;17		; X
dPlat_Y		equ 18;19		; X

dTop		equ 20;21		; Clipping Y's
dBott		equ 22;23		;
dLeft		equ 24;25		; Clipping Y's
dRight		equ 26;27		;

dLife		equ 28;29		; It's life-time in frames

dpMove		equ 30;31		; Ptr to move routine
dpHit		equ 32;33		; Ptr to shot routine

dcStep		equ 34;35		; Where we are
dnStep		equ 36;37		; Maxm. number

dShape		equ 38			; The sprite number
dHits		equ 39			; The number of hits

lSpace		equ 40			; Length of data

; Create the free-space table

Init_Free:	mov di,o Free_Space	; Clear the memory

		mov cx,lSpace*nSpace	; This much RAM

		mov al,0		; Clear to 00

		push es			; Save

		push cs			; In cs
		pop es			;

		rep stosb		; Clear it all

		pop es			; Restore

		; Now fragment it

		mov si,o Free_Space	; Set up the list

		mov cs:pFree,si		; Point at the first block

		mov cx,nSpace-1		; This much

IF_Lp:		lea bx,lSpace[si]	; Point at the next block

		mov cs:dpNext[si],bx	; Link to it

		mov si,bx		; Point at the next

		loop IF_Lp		; Loop

		; Kill the last block

		mov w cs:dpNext[bx],0	; Kill the last block

		; Clear the lists

		call Init_Things	; Clear the things

		call Init_Projs		; Clear the projectiles

		call Init_Fizzles	; Clear the fizzles

		; Done

		ret			; Done

; Init the things

Init_Things:	mov w cs:pThings,0	; Kill the list
		ret			; Done

; Init the projectiles

Init_Projs:	mov w cs:pProjs,0	; Kill the list
		ret			; Done

; Init the fizzles

Init_Fizzles:	mov w cs:pFizzles,0	; Kill the list
		ret			; Done

; Get a free block

Get_Free:	mov di,cs:pFree		; Get a block

		cmp di,0		; NZ = ok
		jz GF_Fail		; Fail, none

		push ax			; Save

		mov ax,cs:dpNext[di]	; Point at the next one
		mov cs:pFree,ax		; Setup the ptr

		pop ax			; Restore

		clc			; Ok
		ret			;

GF_Fail:	stc			; Fail
		ret			; Done

; Release a block

Put_Free:	push ax			; Save

		mov ax,cs:pFree		; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pFree,di		; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a thing

Add_Thing:	push ax			; Save

		mov ax,cs:pThings	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pThings,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a proj

Add_Proj:	push ax			; Save

		mov ax,cs:pProjs	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pProjs,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a fizzle

Add_Fizzle:	push ax			; Save

		mov ax,cs:pFizzles	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pFizzles,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Variables
		align 2			; Word aligned

pFree		dw 0			; Ptr to free space

pThings		dw 0			; Ptr to monsters

pProjs		dw 0			; Ptr to projectiles

pFizzles	dw 0			; Ptr to projectiles

Free_Space	db lSpace * nSpace dup (?) ; Some room for things
Free_End	equ this byte		   ; Endit
