; Play a game, given al = nz for replay

vGame_Ends:	jmp Game_Ends		; Vector off

Play_One:	call far ptr F_Link_Kbd	; Enable the game keys

		; Do we have a mouse ?

		call Init_Mouse		; Start the mouse

		; Start the noises

		call Init_Noises	; Start the driver

		; Start the status displays

		call Init_Status	; Start the status display

		; Init the first sheet

		mov al,0		; Sheet 0
		call Init_Sheet		;
		jc vGame_Ends		; Failed, exit

		; Clear the free-space

		call Init_Free		; Setup the free-space

		; Place the player

		call Init_Player	; Setup the player

		; Setup the palette

		call Init_Move_Pall	; Setup the palettes

;	call Create_Map

		; Reduce the screen size

		call Set_320_200	; Set the full screen

		; Show game screen

		call Init_Display	; Setup the screen

		; Start the intro text

		call Init_Intro		; Set it up

		; Start the weapons

		call Init_Fire		; Set it up

		; Start the platforms

		call Init_Platforms	; Set them up

		; Start the things (monsters)

		call Create_Things	; Set them up

		; Draw everything

		call Update_Screen	; Update the display

		; Show the background	

		call Draw_Background	; Draw some garbage

		; Now, draw any raised backdrop

		call Draw_Raised	; Show it

		; Show the player

		call Show_Player	; Show us

		call Update_Screen	; Update it
		call Swap_Pages		; Back again

		; Pause to allow the display to settle

		call Frame_Lock		; Lock it
		call Drive_Back_Pall	; Drive the background palette

		mov cx,80		; Wait a bit

Pause_Lp1:	call Frame_Lock		; 1/60th sec
		loop Pause_Lp1		;

		; Now, fade it in

		mov b cs:Pre_Cnt,0	; Start with 0 (black)

Pre_Lp:		call Frame_Lock		; Lock it

		; Write the changing palettes

		mov cl,cs:Pre_Cnt	; Get the scale-factor
		call Fade_Palette	; Fade it up

		; Step the palette

		add b cs:Pre_Cnt,8	; Step it
		jnz Pre_Lp		; Loop

		; Now, set the palette

		call Write_All_Palette	; Write it

		; Now, just loop until fire

PG_Lp:		call Noise_Frame	; Clear the flags

		call Frame_Lock		; Lock to the frame code
;		call Frame_Lock

	call far ptr Test_F10
	jnz PG_Lp

		; Write the changing palettes

		call Drive_Back_Pall	; Drive the background palette

		call Update_Screen	; Update the display

		; Get a cheap random

		call Rand_32		; Giz a rand
		mov cs:Cheap_Rand,ax	; Set it

		; Is the mouse change button pressed ?

		call Get_Mouse_Butt	; Get zem
		test al,06h		;
		jz PG_NM		; No, skip

		jmp PG_Mouse		; Yes, skip

	; Now, move the player

PG_NM:		call Clear_Solids	; Clear the list of solids

;		call Move_Platforms
;		call Move_Player

;		call Clear_Solids

;		call Move_Platforms
;		call Move_Player

;		call Clear_Solids	; No surfaces yet

		; Now, move the platforms

		call Move_Platforms	; Move them

		; Show the player

		call Move_Player	; Move the player
		call Move_Window	; Move the window

		; Show the background	

		call Draw_Background	; Draw some garbage

		; Now, draw any platforms

		call Draw_Platforms	; Show them

		; Show some text

		call Show_Text		; Show it

		call Show_Player	; Show the player

		; Drive the weapons

		call Drive_Weapons	; Show them
;		call Drive_Weapons

		; Show some things

		call Move_Things	; Show them

		; Drive the objects

		call Show_Objects	; Show them

		; Now show any fizzles

		call Show_Fizzles	; Show them

		; Now, draw any raised backdrop

		call Draw_Raised	; Show it

		; Now show the startup text until key activity

		call Show_Intro		; Show it

		; Now show the cursor posn

		call Show_Mouse_XY	; Show it

		; Now, update the status screen

		call Show_Status	; Show it

		; Drive the mouse

		call Get_Mouse_XY	; Update the posn

		call far ptr Test_Esc	; Fire pressed ?
		jnz Game_Ends		; Yes, exit

		jmp PG_Lp		; No, loop

; Exit to front-end

Game_Ends:	call far ptr F_Unlink_Kbd; Release the keys

		; Now fade it out

		; Pause to allow the display to settle

		mov cx,20		; Wait 1/3 sec

Pause_Lp2:	call Frame_Lock		; 1/60th sec
		loop Pause_Lp2		;

		; Now, fade it out

		mov b cs:Pre_Cnt,248	; Start with max

Post_Lp:	call Frame_Lock		; Lock it

		; Write the changing palettes

		mov cl,cs:Pre_Cnt	; Get the scale-factor
		call Fade_Palette	; Fade it up

		; Step the palette

		sub b cs:Pre_Cnt,8	; Step it
		jnz Post_Lp		; Loop

		; Done, exit

	call Restore_Mouse		; Restore the char under the mouse

	call Write_Files

		; Wait a bit

		mov cx,50		; Wait a bit

Pause_Lp3:	call Frame_Lock		; 1/60th sec
		loop Pause_Lp3		;

		; Return the score

		mov ax,cs:Score		; Score

		ret			; Leave the game

; Mouse, step the char using the direction flags

PG_Mouse:	call Get_Dirn_Step	; Giz a step value (0,+/-1 +/-16)

		cmp al,cs:Old_Step	; Same ?
		je PG_M_X

		mov cs:Old_Step,al	; Store it

		mov bx,cs:Mouse_Char	; Get the char
		add bl,al		; Step it
		mov cs:Mouse_Char,bx	;

PG_M_X:		jmp PG_NM		; Skip

; Get a dirn key as a step-value

Get_Dirn_Step:	mov bx,0100h		; Value/Step

		call far ptr Test_Right	; +1
		jz GDS1

		add bl,bh		; Step

GDS1:		call far ptr Test_Left	; -1
		jz GDS2

		sub bl,bh		; Step

GDS2:		mov bh,16		; Step size

		call far ptr Test_Up	; -16
		jz GDS3

		sub bl,bh		; Step

GDS3:		call far ptr Test_Down	; +16
		jz GDS4

		add bl,bh		; Step

GDS4:		mov al,bl		; Get the step
		ret			; Done

; Includes

		include screen.inc	; The display drivers

		include sprites.inc	; The sprite-drawing code

		include backdrop.inc	; Drive the background screen

		include sheets.inc	; Drive the sheetfiles

		include mouse.inc	; Drive the mouse

		include player.inc	; Drive the player

		include fire.inc	; Drive the weapons

		include proj.inc	; Drive the things' weapons

		include status.inc	; Drive the status displays

		include file.inc	; Drive the files

		include text.inc	; Drive the text

		include objects.inc	; Drive the objects

		include fizzle.inc	; Drive the fizzles

		include intro.inc	; Drive the intro text

		include platform.inc	; Drive the platform about

		include noises.inc	; Drive the sound-blaster about

		include things.inc	; Drive the monsters about

; Vars

		align 2			; Even

Save_SS		dw ?			; Used to save the stack
Save_SP		dw ?			;

Cheap_Rand	dw ?			; Changed every frame

Score		dw ?			; The score

PlayStack	dw ?			; Temp stack hold

Screen_X	dw 450			; The screen posn.
Screen_Y	dw 210			; The screen position

Sheet_No	db 0			; The sheet-number
Old_Step	db 0			; Ths last editor char step

Pre_Cnt		db 0			; Fade up cnt

		align 2			; Even

Map		dw 128 * 64 dup (?)	; The map of this level
		dw 128 dup (0)		; Blank line

	; The object lists

Objects		equ this byte		; Here

pPlats		dw ?			; Point at the platform data
piThings	dw ?			; Point at the monster data

Object_List	db 8192-4 dup (?)	; The objects, etc
