mouse		equ 33h			; Mouse driver int.

; Show the mouse

Show_Mouse_XY:	mov ax,cs:Mouse_X	; Get the X
		add ax,cs:Screen_X	;
		mov bx,ax		;

		mov dx,cs:Mouse_Y	; Y
		add dx,cs:Screen_Y	;

;		add bx,8		; Step X/Y
		sub dx,8		;

		call ShowDec16		; Show it

		mov ax,cs:Mouse_Y	; Get the Y
		add ax,cs:Screen_Y	;
		mov dx,ax		;

		mov bx,cs:Mouse_X	; X
		add bx,cs:Screen_X	;

;		add bx,16		; Step X/Y
		add dx,1		;

		call ShowDec16		; Show it

		; Cross

		mov bx,cs:Mouse_X	; Get the X
		add bx,cs:Screen_X
		mov dx,cs:Mouse_Y	; Y
		add dx,cs:Screen_Y

		mov ax,iCross		;

	push bx

	mov ax,cs:Frame_No
	and ax,63
	add ax,o Beam_Tab
	mov bx,ax
	mov al,cs:[bx]
	pop bx

	cmp al,iRobot1
	jnz SMXY_1

	add dx,13

SMXY_1:		jmp Draw_Sprite		; Show it

Beam_Tab:	db iBeam
		db iBeam
		db iBeam
		db iBeam+1
		db iBeam+1
		db iBeam+1
		db iBeam+2
		db iBeam+2
		db iBeam+2
		db iBeam+3
		db iBeam+3
		db iBeam+4
		db iBeam+5
		db iBeam+4
		db iBeam+5
		db iBeam+6
		db iBeam+7
		db iBeam+7
		db 48 dup (iRobot1)
		db 0,0,0,0,0,0
		db 0,0,0,0,0,0,0,0
		db 0,0,0,0,0,0,0,0
		db 0,0,0,0,0,0,0,0
		db 0,0,0,0,0,0,0,0
		db 0,0,0,0,0,0,0,0


; Is it there ?

Init_Mouse:	mov ax,-20		; Clear the posn
		mov cs:Mouse_X,ax	;
		mov cs:Mouse_Y,ax	;
		mov cs:Under_Mouse_F,al	;

		; Do we have a mouse ?

		mov ah,35h		; Get int. vector
		mov al,Mouse		; Vector number

		int dos			; Get it (ES:BX)

		mov ax,es		; Get it
		or ax,bx		; Valid vector ?
		jz NoMouse		; No, no driver code

		mov al,0		; Not present flag

		cmp b es:[bx],0CFh	; Points at a RETI ?
		jz NoMouse		; Not a valid routine

		; Assume there is a mouse driver present

		mov ax,0		; Initialise the driver
		int Mouse		;

		mov al,1		; Present

NoMouse:	mov cs:Mouse_Present,al	; Flag present

		ret			; Done

; Get the mouse posn into Mouse_X and Mouse_Y

GM_X:		ret			; Exit

Get_Mouse_XY:	mov cx,0		; 0
		mov dx,0		; 0

		test b cs:Mouse_Present,-1 ; Got one ?
		jz GM_X			   ; No, exit

		mov ax,0Bh		; Get dX ( and dY )
		int Mouse		;

		add cs:Mouse_X,cx	; Create the X
		add cs:Mouse_Y,dx	; And Y

;	ret

		; Calc the ptr

		mov ax,cs:Mouse_Y	; Giz the Y
		sar ax,1		; / 32

		add ax,cs:Screen_Y	; + base

		sar ax,1		;
		sar ax,1		;
		sar ax,1		;
		sar ax,1		;

		and ax,03Fh		; 0 .. 63

		add ax,ax		; * 128
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		mov bx,cs:Mouse_X	; Giz the X

		sar bx,1		; / 32

		add bx,cs:Screen_X	; + base

		sar bx,1		;
		sar bx,1		;
		sar bx,1		;
		sar bx,1		;

		and bx,07Fh		; 0 .. 128

		add ax,bx		; Combine

		add ax,ax		; * 2

		add ax,o Map		; Add base of map

		; Do we have a cell under the mouse ?

		test b cs:Under_Mouse_F,-1; Anything ?
		jz GMXY_1		; No, skip

		; Yes, put it back

		mov bx,cs:Mouse_Ptr	; Get the old ptr
		mov cx,cs:Under_Mouse	; Old cell
		mov cs:[bx],cx		; Restore it

		; Get the new address

GMXY_1:		mov bx,ax		; Get it
		mov cs:Mouse_Ptr,ax	; Store it

		mov ax,cs:[bx]		; Get the cell under it
		mov cs:Under_Mouse,ax	; Save it

		mov b cs:Under_Mouse_F,1; Assert saved

		; Now, is the write button pressed ?

		call Get_Mouse_Butt	; Giz the buttons

		test al,1		; Write ?
		jz GMXY_NW		; No, skip

		; Write this cell, should we clear it ?

		call far ptr Test_Fire	; Fire ?

		mov ax,0030h		; Background ?
		jnz GM_Set		; Yes, skip

		; Write this cell, should we set it ?

		call far ptr Test_F1	; F1 ?

		mov ax,cs:Mouse_Char	; New char ?
		jnz GM_Set		; Yes, skip
		
		; Lower it ?

		call far ptr Test_DA	; Down arrow ?
		jnz GM_Lower		; Yes, skip

		; Raised ?

		call far ptr Test_UA	; Up arrow ?
		jnz GM_Raise		; Yes, skip

		; Soften it ?

		call far ptr Test_F2	; F2 ?
		jnz GM_Soften		; Yes, skip

		; Harden it ?

		call far ptr Test_F3	; F3 ?
		jnz GM_Harden		; Yes, skip

		; Nothing pressed, ignore it

		jmp s GMXY_NW		; Skip

	; Lower to the background

GM_Lower:	mov ax,cs:Under_Mouse	; Get it
		and ax,0FF7Fh		; Kill the raised bit

		jmp s GM_Set		; Write it

	; Raise it

GM_Raise:	mov ax,cs:Under_Mouse	; Get it
		or ax,0080h		; Set the raised bit

		jmp s GM_Set		; Write it

	; Soften it

GM_Soften:	mov ax,cs:Under_Mouse	; Get it
		and ax,0FEFFh		; Kill the hard bit

		jmp s GM_Set		; Write it

	; Harden it

GM_Harden:	mov ax,cs:Under_Mouse	; Get it
		or ax,0100h		; Set the soft bit

		jmp s GM_Set		; Write it

	;

GM_Set:		mov cs:Under_Mouse,ax	; Write it

		; Now, show the mouse

GMXY_NW:	mov ax,003Ah		; The mouse char

		test b cs:Frame_No,1	; Odd/Even ?
		jz GMXY_2		; Even

		mov ax,cs:Mouse_Char	; Get the new one

GMXY_2:		mov cs:[bx],ax		; The mouse ptr

		; Exit

GMXY_X:		ret			; Done

; Restore the char under the mouse

Restore_Mouse:	test b cs:Under_Mouse_F,-1; Anything ?
		jz RM_X			; No, skip

		; Yes, put it back

		mov bx,cs:Mouse_Ptr	; Get the old ptr
		mov cx,cs:Under_Mouse	; Old cell
		mov cs:[bx],cx		; Restore it

RM_X:		ret			; Done

; Get the mouse button state

Get_Mouse_Butt:	push bx			; Save

		mov al,0		; Dummy key status

		test b cs:Mouse_Present,-1 ; Got a rodent ?
		jz GMB_X		   ; No

		mov ax,3		; Get mouse button state
		int Mouse		;

		mov al,bl		; Get them
		and al,07h		; Three buttons only

GMB_X:		pop bx			; Restore
		ret			; Done

; Vars

Mouse_Present	db ?			; NZ = Present

Mouse_X		dw ?			; X posn, in mickeys
Mouse_Y		dw ?			; Y posn

Mouse_Ptr	dw ?			; Ptr
Under_Mouse	dw ?			; Cell under the mouse
Mouse_Char	dw ?			; Mouse_Cell

Under_Mouse_F	db ?			; NZ = cell stored
