; This code moves the player

pfJump		equ 01h			; Flag for jump
pfLeft		equ 02h			; Flag for left
pfRight		equ 04h			; Flag for right
pfLR		equ 06h			; Both flags

Player_X_Step	equ 30			; Step size (X)
Player_Max_dX	equ 400h		; 4 pixels/frame

Max_dY		equ 9*256		; Maxm fall rate

View_XO		equ View_Width/3	;
View_YO		equ View_Height/4-10	;

Jump_dY		equ -850		; This many
Player_Grav	equ 20			;
Player_Grav_1	equ 34			; Extra if jump not pressed

Ply_X_Width	equ 5			; Damage size
Ply_Y_Height	equ 10			;

; Init the player

Init_Player:	mov w cs:Player_X,134	; X
		mov b cs:Player_fX,0	;

		mov w cs:Player_Y,18*16 ; Y
		mov b cs:Player_fY,0	;

		mov w cs:Player_dX,1	; dX
		mov w cs:Player_dY,0	; dY

		mov b cs:Player_OK,0	; Old key flags
		mov b cs:Player_State,0	; Standing
		mov w cs:Leg_Phase,0	; Middle

		mov b cs:Player_Dirn,0	; Direction
		mov b cs:Play_F_Vect,1	; R

		mov b cs:Player_Squash,0; Not squashed

		mov w cs:Screen_X,32	; Move the window
		mov w cs:Screen_Y,14*16	;

		call Move_Window	; Place the window

		ret			; Done

; Move the player		

Move_Player:	mov ax,cs:Player_X	; Save the X
		push ax			;

		mov ax,cs:Player_Y	; Save the Y
		push ax			;

		call Move_Player_1	; Move him

		; Now, calc the clip box

		pop dx			; Y
		pop bx			; X

		; Moved left ?

		mov ax,cs:Player_X	; New X
		cmp ax,bx		; > ?
		jc MPC_1		; No, skip

		; Swap

		xchg ax,bx		; Order them

MPC_1:		sub ax,Ply_X_Width	; Calc clip box
		mov cs:Player_LHS,ax	;

		add bx,Ply_X_Width	; Calc clip box
		mov cs:Player_RHS,bx	;

		; Moved up ?

		mov ax,cs:Player_Y	; New Y
		cmp ax,dx		; > ?
		jc MPC_2		; No, skip

		; Swap

		xchg ax,dx		; Order them

MPC_2:		sub ax,Ply_Y_Height+21	; Calc clip box
		mov cs:Player_TOP,ax	;

		add dx,Ply_Y_Height-12	; Calc clip box
		mov cs:Player_BOTT,dx	;

		ret			; Done

	; Move him

Move_Player_1:	mov al,cs:PT_Plat_F	; Save the state of the Platform f
		mov cs:PT_Old_Plat_F,al	;

		sub ax,ax		; 00

		mov cs:PT_Plat_F,al	; Not on a platform

		mov cs:Player_Impact,ax	; Not landed or jumped

		mov bl,0		; Clear the flags

		; Jump ?

		call far ptr Test_Up	; Jump ?
		jz MP_NJ		; No, skip

		or bl,pfJump		; Set the flag

MP_NJ:		call far ptr Test_Left	; Move left ?
		jz MP_NL		; No, skip

		or bl,pfLeft		; Set the flag

MP_NL:		call far ptr Test_Right	; Move right ?
		jz MP_NR		; No, skip

		or bl,pfRight		; Set the flag

		; We have the flags for left/right/jump

MP_NR:		or b cs:Key_Pressed,bl	; Kill the intro

		; Move

		mov bh,cs:Player_OK	; Get the old keys
		mov cs:Player_OK,bl	; Save them

		xor bh,bl		; Set the changed flags

		; BH = changed key flags

		mov al,bl		; Get the left/right flags
		and al,pfLR		;

		mov ah,0		; Assume right
		mov cx,+Player_X_Step	; Assume right

		cmp al,pfRight		; Right ?
		jz MP_GotdX		; Yes, skip

		inc ah			; Left
		mov cx,-Player_X_Step	; Assume left
		cmp al,pfLeft		; Left ?
		jz MP_GotdX		; Yes, skip

		mov cx,0		; No X step
		mov ah,cs:Player_Dirn	; Same dirn

		; cx = -1/0/+1

MP_GotdX:	mov cs:Player_Dirn,ah	; Set the dirn

		; Decay if neither pressed

		cmp cx,0		; 0 ?
		jne MPGdX_1		; No, skip

		; Decay the dX

		mov cl,4		; / 16
		mov ax,cs:Player_dX	; Get dX

		sar ax,cl		; /n

		neg ax			; Negate it
		mov cx,ax		;

MPGdX_1:	add cx,cs:Player_dX	; Calc displacement, and clip into range
		js MP_Neg_dX		; -ve, skip

		cmp cx,Player_X_Step	; Small ?
		jb MP_Zero_dX		; Yes, kill it

		cmp cx,Player_Max_dX	; In range ?
		jb MP_dX_OK		; Yes, skip

		mov cx,Player_Max_dX	; Clip it

		jmp s MP_dX_OK		; Skip

MP_Zero_dX:	mov cx,0		; Kill it

	; Clip -ve

MP_Neg_dX:	neg cx			; Invert

		cmp cx,Player_Max_dX	; In range ?
		jb MP_Neg_dX_OK		; Yes, skip

		mov cx,Player_Max_dX	; Clip it

MP_Neg_dX_OK:	neg cx			; Invert

MP_dX_OK:	mov cs:Player_dX,cx	; Save it

		; Now, drive the Y

MP_dX_0:	mov al,cs:Player_State	; Get the state value
		cmp al,1		; Walking/Standing ?
		jbe vMP_Stand		; Yes, skip

		cmp al,2		; Jumping ?
		je vMP_Rise		; Yes, skip

		; Falling

MP_Fall:	mov cx,cs:Player_dY	; dY

	; We are jumping, apply gravity

MP_Got_dY:	test bl,pfJump		; Still pressed ?
		jne MP_GY_1		; Yes, skip

		add cx,Player_Grav_1	; Extra

MP_GY_1:	add cx,Player_Grav	; Step the dY

		; Clip and save the Y-Step

		cmp cx,Max_dY		; In range ?
		jl MP_GdY1		; Yes, skip

		mov cx,Max_dY		; Clip it

MP_GdY1:	mov cs:Player_dY,cx	; Now, can we do this move ?

MP_No_dY:	call Player_Test_X	; Is the X-step OK ?
		jnc MP_X_Ok		; Yes, do it

		mov w cs:Player_dX,0	; Clear the X-step
		mov b cs:Player_fX,0	;

MP_X_Ok:	call Player_Test_Y	; Is the Y-step OK ?
		jnc MP_Y_Ok		; Yes, do it

		; ax = Y

		; We are standing on something, were we falling ?

		mov bx,cs:Player_dY	; Falling ?
		cmp bx,0		;
		jz MP_Walking		; No, skip

		; We were falling, squash if it was fast enough

		call ns_Landing		; Make the noise !!

		push bx			; Save
		push ax			;

		mov bl,bh		; Look in the table
		mov bh,0		;
		add bx,o Squash_Offs	;

		mov al,cs:[bx]		; Get ptr
		
		mov cs:Player_Squash,al	; Squashed

		mov ax,cs:Player_dY	; Impact
		mov cs:Player_Impact,ax	;

		pop ax			; Restore
		pop bx			;
		
MP_Walking:	mov w cs:Player_dY,0	; Clear the Y-step
		mov b cs:Player_State,1	; Walking

		; Move the Y to the top of the block

		mov cs:Player_Y,ax	; Force to the right pixel

		jmp s MP_Y_Ok		; Skip

; Vector

vMP_Stand:	jmp MP_Stand		; Vectors
vMP_Fall:	jmp MP_Fall		;
vMP_Rise:	jmp MP_Rise		;

	; Start jumping

MP_Set_Rise:	mov b cs:Player_State,2	; Rising

		mov b cs:Player_Squash,0; Not squashed

		; Set the impact velocity

		mov ax,cx		; Impact
		neg ax			;
		mov cs:Player_Impact,ax	;

		jmp MP_Got_dY		; Skip

	; Rising

MP_Rise:	test b cs:Player_dY+1,80h ; -ve ?
		jne vMP_Fall		  ; No, skip

MP_Set_Fall:	mov b cs:Player_State,3	; Falling

		mov cx,0		; Not moving yet
		jmp MP_Got_dY		; Skip

		; We have the move, do it

MP_Y_Ok:	mov cx,cs:Player_dX	; X-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cs:Player_fX,cl	; 24-bit add
		adc cs:Player_X,ax	; Accumulate the X

		; Now the Y

		mov cx,cs:Player_dY	; Y-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cs:Player_fY,cl	; 24-bit add
		adc cs:Player_Y,ax	; Accumulate the Y

		; Assume not on a platform

		sub ax,ax		; 0
		mov cs:Plat_dX,ax	; No move
		mov cs:Plat_dY,ax	;

		; Now, if we are standing on a platform, we move with it

		test b cs:PT_Plat_F,-1	; On one ?
		jz MP_NoPlat		; No, skip

		; Were we on one ?

		test b cs:PT_Old_Plat_F,-1; Were we ?
		jz MP_Plat_1		  ; No, skip

		; Yes, follow it in X

		mov ax,cs:PT_Plat_X	; New
		sub ax,cs:PT_Old_Plat_X ; Old

		; Is this a valid difference ?

		mov bx,ax		; Save it
		jns MP_Plat_0		;

		neg bx			; Abs dX

MP_Plat_0:	cmp bx,5		; < 5 ?
		jae MP_Plat_1		; No, behave as though we were not
					; On one

		; Ok, lets assume that this is the same platform and follow it

		add cs:Player_X,ax	; Move us

		mov ah,al		; * 256
		mov al,0		;

		mov cs:Plat_dX,ax	; Vector

		; Yes, follow it in Y

		mov ax,cs:PT_Plat_Y	; New
		mov cs:Player_Y,ax	;

		sub ax,cs:PT_Old_Plat_Y ; Old

		mov ah,al		; * 256
		mov al,0		;

		mov cs:Plat_dY,ax	; Vector

		; Save to old posn

MP_Plat_1:	mov ax,cs:PT_Plat_X	; New
		mov cs:PT_Old_Plat_X,ax	; Save it

		mov ax,cs:PT_Plat_Y	; New
		mov cs:PT_Old_Plat_Y,ax	; Save it

MP_NoPlat:	;call Move_Window	; Move it (if we must)

		; Now, test if we should fire

		jmp Player_Fire		; kip

; Vectors

vMP_Set_Fall:	jmp MP_Set_Fall		; Vector

	; We are not moving in Y, is there something below us ?

MP_Stand:	push bx			; Save

		; We are stat. / falling

		mov bx,cs:Player_Y	; Accumulate the Y
		mov dl,bl		; Save the offset into the block

		mov ax,cs:Player_X	; Get the X
		sub ax,8		; LHS

		mov cx,ax		; RHS
		add cx,14		;

		call Check_Stand	; Are we standing on anything ?

		pop bx			; Restore

		jnc vMP_Set_Fall	; No, fall

		; Is the jump button pressed ?

		test bh,pfJump		; Has it changed ?
		je vMP_No_dY		; No, skip

		test bl,pfJump		; Jumping ?
		je vMP_No_dY		; No, skip

		; Jump

		call Get_Player_Sq	; Amount squashed
		mov ah,al		;

		mov cl,3		; /8
		sar ax,cl		;	
	
		mov cx,Jump_dY		; Assume jumping
		sub cx,ax		; Increase the jump amount
		
		jmp MP_Set_Rise		; Start to rise

vMP_No_dY:	jmp MP_No_dY		; Vector

; Can we move in X ?

Player_Test_X:	mov ax,cs:Player_dX	; Get the current dX
		cmp ax,0		; Any ?
		je PTX_X		; No, skip

		; Yes, +/- ?

		jns PTX_R		; Skip if moving right

		sub ax,8*256		; Left
		jmp s PTX_1		; Skip

PTX_R:		add ax,8*256		; Right

PTX_1:		mov bx,ax		; X-step
		mov al,ah		; Make 24-bit
		cbw			;

		add bl,cs:Player_fX	; 24-bit add

		mov bx,cs:Player_X	; Get the old X
		adc ax,bx		; Accumulate the X

		; Is this the same block ?

		xor bx,ax		; Get any different bits
		and bl,0F0h		; Different block ?
		je PTX_X		; No, exit

		; Different. Get a pointer to the appropriate block.

		mov bx,cs:Player_Y	; Get the Y
		sub bx,28		; Up

		; Get a pointer to this block

		push ax			; Save X
		push bx			; Y

		call Calc_pMap		; Point at this block
		mov si,ax		; Get it

		pop bx			; Restore Y
		pop ax			; X

		jc PTX_Solid		; Solid

		; Now, try down

		add bx,27		; Move down

		call Calc_pMap		; Point at this block
		jc PTX_Solid		; Solid

		mov bx,ax		; Save the ptr

		; Loop examining blocks until a solid one found

PTX_Lp:		test w cs:[si],0100h	; Solid ?
		jne PTX_Solid		; No, skip

		cmp si,bx		; Done ?
		je PTX_X		; Yes, skip

		add si,128*2		; Move down

		jmp s PTX_Lp		; Loop

	; Solid, return CF

PTX_Solid:	stc			; Solid
		ret			;

PTX_X:		clc			; Clear
		ret			;

; Can we move in Y ? (return ax = Y of the block we hit if failed)

Player_Test_Y:	mov ax,cs:Player_dY	; Which way are we going ?
		cmp ax,0		;
		js PTY_Up		; Up, ok

		; We are stat. / falling

		mov cx,ax		; Y-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cl,cs:Player_fY	; 24-bit add
		adc ax,cs:Player_Y	; Accumulate the Y

		mov bx,ax		; Get the Y
		mov dl,bl		; Save the offset into the block

		mov ax,cs:Player_X	; Get the X
		sub ax,5		; LHS

		mov cx,ax		; RHS
		add cx,9		;

Check_Stand:	mov cs:PT_LHS,ax	; Save them
		mov cs:PT_RHS,cx	;
		mov cs:PT_Y,bx		;

		call Check_Floor	; Are we standing on anything ?
		jnc PTY_Solid		; No, look for a platform

		ret			; Done

	; Going up, hit roof ?

PTY_Up:		mov ax,35		; Limit

		cmp ax,cs:Player_Y	; Giz the Y
		jb PT_Yes		; Yes, skip

		mov cs:Player_Y,ax	; Clip it
		mov w cs:Player_dY,0	;

		; We can fall through this block

PT_Yes:		clc			; Yes
		ret			;

	; Are we on a platform ?

PTY_Solid:	push di			; Save

		mov di,o Solid_List	; Point at the list

PTYS_Lp:	mov ax,cs:4[di]		; Width
		cmp ax,0		; End ?
		je PTYS_X		; Yes, exit

		mov bx,cs:[di]		; Centre of platform
		sub bx,ax		; LHS

		cmp bx,cs:PT_RHS	; Overlap ?
		jae PTYS_Next		; No skip

		add bx,ax		; RHS
		add bx,ax		;

		cmp bx,cs:PT_LHS	; Overlap ?
		jb PTYS_Next		; No, skip

		; X is OK, what about the Y ?

		mov ax,cs:2[di]		; Get ze Y

		sub ax,3
		cmp ax,cs:PT_Y		; Above the platform ?
		ja PTYS_Next		; Yes, skip

		add ax,10+3		; Up to 10 below it ?
		cmp ax,cs:PT_Y		;
		jbe PTYS_Next		; No, skip

		; We are standing on this platform

		sub ax,10		; Return the Y

		mov b cs:PT_Plat_F,1	; Yes, we are on one

		; Point at the platform and flag that we are on it

		mov bx,cs:6[di]		; pPlat
		or w cs:dpFlags[bx],2	; Hit the flag

		mov cx,o Player_dY	  ; Point at the dY
		mov cs:dppOccupier[bx],cx ;

		mov bx,cs:[di]		; Save the platform posn
		mov cs:PT_Plat_X,bx	;
		mov cs:PT_Plat_Y,ax	;

		stc			; Hit
		pop di			; Restore
		ret			; Done

PTYS_Next:	lea di,8[di]		; Skip this one
		jmp s PTYS_Lp		; Loop

PTYS_X:		clc			; No
		pop di			; Restore
		ret			; Done

; Given ax = LHS, cx = RHS and bx = Y check if solid and return ax = Y of top

CF_Fail:	stc			; Failure
		mov ax,63*16		; Dummy top
		ret			; Done

Check_Floor:	mov bp,ax		; Save the LHS
		and bp,000Fh		; 0 to 15
		add bp,bp		; * 2

		sub cx,ax		; dh = Width
		mov dh,cl		;

		mov dl,al		; X-Offset
		not dl			; Invert
		and dl,0Fh		; 15 .. 0
		inc dl			; 16 .. 1

		push bx			; Save
		call Calc_pMap		; Point at the LHS block
		pop bx			; Restore
		jc CF_Fail		; Out-of-range, skip

		mov si,ax		; Save the ptr

		; Now, setup the offset into this block

		mov cl,17		; Offset = illegal
		mov ch,bl		; Y-Offset
		and ch,0Fh		; 0 .. 15

		; Now, scan all the relevant blocks

CF_Scan_Next_B:	mov ax,cs:[si]		; LHS block
		test ax,0100h		; Solid ?
		jnz CFSB_Top		; Yes, skip

		and ax,007Fh		; 0 .. 127

		add ax,ax		; * 2

		add ax,o Block_pHeights	; Look-up the heights

		mov di,ax		; Point at the block-pixel height data
		mov di,cs:[di]		; Point at the defn
		add di,bp		; Offset for X

		; Now, scan across this block looking at the thickness/height

CF_Scan_Block:	mov ax,cs:[di]		; Get the min/max
		inc di			;
		inc di			;

		; Check it

		cmp al,ch		; Are we above the bottom of the solid ?
		jbe CFSB_1		; No, we are below, ignore this

		cmp ah,cl		; Are we already above the top of it ?
		jae CFSB_1		; Yes, skip

		mov cl,ah		; New height

		cmp ah,0		; Up a block ?
		je CFSB_X		; Yes

		; Next pixel

CFSB_1:		dec dh			; One less
		jz CFSB_X		; Done, skip

		dec dl			; Loop across this block
		jnz CF_Scan_Block	;

		; Next block to the right

		inc si			; Skip one block
		inc si			;

		mov bp,0		; Offset into block

		jmp s CF_Scan_Next_B	; Move right

	; Assume top of block

CFSB_Top:	mov cl,1		; Top
		
	; Now, what was the highest

CFSB_X:		dec cl			; -1 .. 15

		cmp cl,16		; Didn't hit anything . . .
		je CF_Clear		; No, skip

		; We hit something, return the highest point

		mov ax,si		; Calc Y of the top of the block

		sub ax,o Map		;
		mov al,ah		; /256
		mov ah,0		;

		add ax,ax		; * 16
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		xchg ax,cx		; Swap

		cbw			; 16-bit offset
		add ax,cx		; Move down/Up

		stc			; Solid
		ret			;

CF_Clear:	clc			; Not solid
		ret			;

; Given ax = X, bx = Y return bx = pBlock

Calc_pMap:	cmp bx,64*16		; Out-of-range ?
		jae CpM_F		; Yes, skip

		cmp ax,128*16		; Out-of-range ?
		jae CpM_F		; Yes, skip

		shr bx,1		; /16
		shr bx,1		;
		shr bx,1		;
		shr bx,1		;

		mov bh,bl		; Y * 128 * 2
		mov bl,0		;

		shr ax,1		; X/16
		shr ax,1		;
		shr ax,1		;
		shr ax,1		;

		add ax,ax		; * 2

		add ax,o Map		; Add base

		add ax,bx		; Add X

		ret			; Done (nc)

CpM_F:		stc			; Fail (c)
		ret			;

; Move the window

Move_Window:
		mov ax,cs:Player_X	; Get the screen X
		sub ax,View_Width/2
;		mov cs:Screen_X,ax	; Is the player > this ?

		mov ax,cs:Player_Y	; Get the screen X
		sub ax,View_Height/2
;		mov cs:Screen_Y,ax	; Is the player > this ?


		mov ax,cs:Player_X	; Get the screen X
		sub ax,cs:Screen_X	; Is the player > this ?

		cmp ax,View_XO		; <LHS ?
		jb MW_LHS		; No, move the view

		cmp ax,View_Width-View_XO ; In the middle ?
		ja MW_RHS		; No, move the view

		; Now check Y

MW_XD:		mov ax,cs:Player_Y	; Get the screen Y
		sub ax,cs:Screen_Y	; Is the player > this ?

		cmp ax,View_YO+24	; <TOP ?
		jb MW_TOP		; No, move the view

		cmp ax,View_Height-View_YO ; In the middle ?
		ja MW_BOTT		; No, move the view

		; We are in the window, clip to the map-edges

MW_YD:		mov ax,cs:Screen_X	; Giz the X
		mov bx,cs:Screen_Y	; And Y

		cmp ax,0		; -ve ?
		jns MW_X1		; No, skip

		mov ax,0		; Clip to the LHS

MW_X1:		cmp ax,128*16-View_Width; RHS ?
		jb MW_X2		; No,skip

		mov ax,128*16-View_Width; Clip to the TOP

MW_X2:		cmp bx,0		; -ve ?
		jns MW_Y1		; No, skip

		mov bx,0		; Clip to the BOTT

MW_Y1:		cmp bx,64*16-View_Height; BOTT ?
		jb MW_Y2		; No,skip

		mov bx,64*16-View_Height; Clip to the BOTT

MW_Y2:		; Save the new (possibly) window

		mov cs:Screen_X,ax	; Save the X
		mov cs:Screen_Y,bx	; And the Y

		ret			; Done

	; We are off the LHS, move the view

MW_LHS:		mov ax,cs:Player_X	; Get the Players' X
		sub ax,View_XO		; Offset
		mov cs:Screen_X,ax	; Save it

		jmp s MW_XD		; Skip

	; We are off the RHS, move the view

MW_RHS:		mov ax,cs:Player_X	; Get the Players' X
		sub ax,View_Width-View_XO; Offset
		mov cs:Screen_X,ax	; Save it

		jmp s MW_XD		; Skip

	; We are off the TOP, move the view

MW_TOP:		mov ax,cs:Player_Y	; Get the Players' Y
		sub ax,View_YO+24	; Offset
		mov cs:Screen_Y,ax	; Save it

		jmp s MW_YD		; Skip

	; We are off the BOTTOM, move the view

MW_BOTT:	mov ax,cs:Player_Y	; Get the Players' X
		sub ax,View_Height-View_YO; Offset
		mov cs:Screen_Y,ax	; Save it

		jmp s MW_YD		; Skip

; Show the player

Show_Player:	mov al,cs:Player_Dirn	; Get the direction flag
		cmp al,0		; Left or Right
		jz SP_1			; Skip if Left

		mov al,1		; Flag Right

SP_1:		mov cs:Play_F_Vect,al	; Assume L/R

		mov bx,cs:Player_X	; Get the player X
		mov dx,cs:Player_Y	; Y

		sub dx,10		; Move up

		mov ah,cs:Player_State	; Get the state

		cmp ah,0		; Standing ?
		je SP_Stand		; Yes, skip

		dec ah			; Walking ?
		je SP_Walk		; Yes, skip

		dec ah			; Jumping ?
		je SP_Jump		; Yes, skip

		dec ah			; Falling ?
		je SP_Fall		; Yes, skip

		; Failed, assume standing

		; The player is standing, draw the standing sprite

SP_Stand:	mov cl,17		; Phase = 17

		jmp SPW_Show		; Show us

	; The player is falling, draw the falling sprite

SP_Fall:	mov cx,cs:Player_dY	; Get the dY
		cmp cx,1*256		; Fast ?
		jbe SP_Stand		; No, as for walking

		mov b cs:Player_Phase,0	; Kill the leg posn

		cmp cx,2*256		; Slight jump ?
		jb SPF_1		; Yes, skip

		add al,sPL_Fall2	; The falling sprite

		add b cs:Play_F_Vect,8	; Set the fire-directions

		jmp Draw_Sprite		; Show us

	; Small fall

SPF_1:		add al,sPL_Fall		; The falling sprite

		add b cs:Play_F_Vect,6	; Set the fire-directions

		jmp Draw_Sprite		; Show us

	; Jumping

SP_Jump:	mov cx,cs:Player_dY	; Get the dY
		neg cx			;
		cmp cx,1*256		; Fast ?
		jb SP_Stand		; No, as for standing

		cmp cx,32000		;
		jae SP_Stand		;

		mov b cs:Player_Phase,0	; Kill the leg posn

		cmp cx,2*256		; Slight jump ?
		jb SPJ_1		; Yes, skip

		add al,sPL_Jump2	; The jumping sprites

		add b cs:Play_F_Vect,4	; Set the fire-directions

		jmp Draw_Sprite		; Show us

	; Small jump

SPJ_1:		add al,sPL_Jump		; The jumping sprites

		add b cs:Play_F_Vect,2	; Set the fire-directions

		jmp Draw_Sprite		; Show us

	; The player is walking

SP_Walk:	mov cx,cs:Player_dX	; Get the step
		cmp cx,0		; 0 ?
		jz SP_Stand		; Yes, stand still

		; negate if required

		sar cx,1		; /2

		test b cs:Player_Dirn,-1;
		jz SPW_A

		neg cx			; Negate

		; Now, should we change the legs ?

SPW_A:		add cx,cs:Leg_Phase	; Accumulate it
		mov cs:Leg_Phase,cx	;

		mov cl,0		; Get step
		sub cs:Leg_Phase,cx	;				

		; Step the phase

		mov cl,cs:Player_Phase	; Step the leg phase
		add cl,ch		;

		cmp cl,200		; +ve ?
		jae SPW_0		; Yes, clip

		cmp cl,17*2		; 0 .. 16 ?
		jb SPW_1		; Yes, skip

		sub cl,17*2		; Wrap

		jmp s SPW_1		; Skip

SPW_0:		mov cl,17*2		; Other end

SPW_1:		mov cs:Player_Phase,cl	; Save the new phase

		shr cl,1		; / 2

		; Show the body/legs given al = dirn, cl = phase

SPW_Show:	push ax			; Save the L/R flag

		; Now, get the leg sprite

		cmp al,0		; Left ?
		je SPW_2		; Yes, skip

		mov al,18		; Right

SPW_2:		add al,cl		; Allow for the phase
		add al,sPL_Legs		; Address the sprite

		push bx			; Save	X
		push dx			;	Y

		call Draw_Sprite	; Show it

		pop dx			;

		; Move the Y of the body down by the squashed amount

		call Get_Player_Sq	; Get the squashed amount, if any
		mov cs:Player_Squash,ah	; Set the new value

		cbw			;
		add dx,ax		; Move Y

		pop bx			; Restore X

		pop ax			; Restore L/R
		add al,sPL_Top		;

		jmp Draw_Sprite		; Show it

	; Drive the squashed mode

Get_Player_Sq:	mov ah,cs:Player_Squash	; Get the squashed amount
		cmp ah,0		; End ?
		jz GPS_Z		; Yes, skip

		mov bl,ah		; Point at the table
		mov bh,0		;
		add bx,o Squash_Tab	; Index the table

		inc ah			; Step along the table

		mov al,cs:[bx]		; Get the squashed' amount

		cmp al,0		; End ?
		jnz GPS_X		; No, skip

GPS_Z:		sub ax,ax		; 0000

GPS_X:		ret			; Done

; Clear the list

Clear_Solids:	mov di,o Solid_List	; Point at the list
		mov w cs:pSolid,di	;

		mov w cs:4[di],0	; Terminate it
		ret			; Done

; Add a surface to the list bx/dx = Centre ax = width di = pPlat

Add_Solid:	push si			; Save

		mov si,cs:pSolid	; Point at the next space
		cmp si,o SL_End		; No room ?
		je AS_X			; No, skip

		mov cs:[si],bx		; X
		mov cs:2[si],dx		; Y
		mov cs:4[si],ax		; Width
		mov cs:6[si],di		; pPlat

		lea si,8[si]		; Move past it

		mov cs:pSolid,si	; Save the ptr

		mov w cs:4[si],0	; End the list

AS_X:		pop si			; Restore
		ret			; Done

; Fixed data

Squash_Offs	db 0
		db Squash_Tab_1-Squash_Tab
		db Squash_Tab_2-Squash_Tab
		db Squash_Tab_3-Squash_Tab
		db Squash_Tab_4-Squash_Tab
		db Squash_Tab_4-Squash_Tab
		db Squash_Tab_5-Squash_Tab
		db Squash_Tab_5-Squash_Tab
		db Squash_Tab_5-Squash_Tab
		db Squash_Tab_6-Squash_Tab
		db Squash_Tab_6-Squash_Tab
		db Squash_Tab_6-Squash_Tab

Squash_Tab	db 0

Squash_Tab_4	db 4,6,4,3,3,2,2,2,1,1,1,1,0

Squash_Tab_5	db 4,6,8,9
Squash_Tab_6	db 10,9,8,7,6,5
Squash_Tab_3	db 4,3,3
Squash_Tab_2	db 2,2,2
Squash_Tab_1	db 1,1,1,1,0

Block_pHeights	dw bhFree,bhFree,bhFree,bhFree	; 0 - 3
		dw bhFree,bhFree,bhFree,bhFree	; 4 - 7
		dw bhFree,bhFree,bhFree,bhFree	; 8 - B
		dw bhFree,bhFree,bhFree,bhFree	; C - F

		dw bhTop			; Flat

		dw bhL_45,bhR_45		; Slopes
		dw bhL_45_B,bhR_45_B		; Slope ends

		dw bhLump			; Lump
		dw bhTop,bhTop			; Flat ends

		dw bhFree,bhFree,bhFree,bhFree	; 18 - 1B
		dw bhFree,bhFree,bhFree,bhFree	; 1C - 1F

		dw bhFree,bhFree,bhFree,bhFree	; 20 - 23
		dw bhFree,bhFree,bhFree,bhFree	; 24 - 27
		dw bhFree,bhFree,bhFree,bhFree	; 28 - 2B
		dw bhFree,bhFree,bhFree,bhFree	; 2C - 2F

		dw bhFree			; 30
		dw bhL_45,bhR_45		; Slopes
		dw bhTop,bhTop			; Flat ends

		dw bhR_45_B,bhL_45_B		; Slope ends

		dw bhFree			; 34 - 37
		dw bhFree,bhFree,bhFree,bhFree	; 38 - 3B
		dw bhFree,bhFree,bhFree,bhFree	; 3C - 3F

		dw 128 dup (bhFree)

; A free block with no solid bits

bhFree		db 0,17,0,17,0,17,0,17	; 00
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;

; A solid top/lhs

bhTop		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;

; A floating lump

bhLump		db 9,4,9,3,9,3,9,2	;
		db 9,2,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,2,9,2,9,3,9,4	;

; LHS slope

bhL_45		db 9,1,10,2,11,3,12,4	;
		db 13,5,14,6,15,7,15,8	;
		db 15,9,15,10,15,11,15,12;
		db 16,13,16,14,16,15,16,16;

; LHS tiny bit

bhL_45_B	db 0,17,0,17,0,17,0,17	; 00
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,8,0,8,0	; These 00's make it move up

; RHS slope

bhR_45		db 16,16,16,15,16,14,16,13;
		db 15,12,15,11,15,10,15,9;
		db 15,8,15,7,14,6,13,5	;
		db 12,4,11,3,10,2,9,1	;

; RHS tiny bit

bhR_45_B	db 8,0,8,0,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;

; Vars

		align 2			; Even

Player_LHS	dw ?			; Clips
Player_RHS	dw ?			;
Player_TOP	dw ?			;
Player_BOTT	dw ?			;

Player_X	dw ?			; The player's X
Player_Y	dw ?			; The player's Y

		; These must be together so they can be pointed to by pOccupier

Player_dX	dw ?			; The player's dX
Player_dY	dw ?			; The player's dY
Player_Impact	dw ?			; The player's dY on landing

Leg_Phase	dw ?			; The players leg change

Player_Dirn	db 0			; 0 = left 1 = right

Player_State	db 0			; 0 = standing
					; 1 = walking
					; 2 = falling
					; 3 = jumping
					; 4 = Standing on a platform

Player_Phase	db 0			; Count in this state

Player_Squash	db 3			; Number of pixels to be shrunk by

Player_fY	db ?			; Fractional Y
Player_fX	db ?			; Fractional X

Player_OK	db ?			; Old key states

Play_F_Vect	db ?			; Ptr to the fire-vectors

PT_Plat_F	db ?			; 0 or 1 (1 = standing on a platform)
					; returned from Player_Test_Y

PT_Old_Plat_F	db ?			; 0 or 1 (1 = standing on a platform)
					; Copy of PT_Plat_F

		align 2			; Even

PT_LHS		dw ?			; LHS of feet
PT_RHS		dw ?			; RHS of feet
PT_Y		dw ?			; Y of feet

PT_Plat_X	dw ?			; Current platform posn
PT_Plat_Y	dw ?			;
PT_Old_Plat_X	dw ?			; Old posn
PT_Old_Plat_Y	dw ?			;

Plat_dX		dw ?			; Player's dx due to platform moves
Plat_dY		dw ?			; Player's dy etc

pSolid		dw ?			; Ptr to a list of surfaces

Solid_List	dw nSolids*4 dup (?)	; A list of surfaces

		; X,Y,Width,pPlatform

SL_End		equ this byte		; End of list
