; This code moves the player

pfJump		equ 01h			; Flag for jump
pfLeft		equ 02h			; Flag for left
pfRight		equ 04h			; Flag for right
pfLR		equ 06h			; Both flags

Player_X_Step	equ 1			; Step size (X)

View_XO		equ View_Width/3	;
View_YO		equ View_Height/4	;

Jump_dY		equ -850		; This many
Player_Grav	equ 17			;
Player_Grav_1	equ 37			; Extra if jump not pressed

; Init the player

Init_Player:	mov w cs:Player_X,134		; X
		mov w cs:Player_Y,19*16 - 15	; Y
		mov b cs:Player_fY,0		; fractional Y

		mov w cs:Player_dX,1	; dX
		mov w cs:Player_dY,0	; dY

		mov b cs:Player_OK,0	; Old key flags
		mov b cs:Player_YF,0	; Not jumping

		mov w cs:Screen_X,32	; Move the window
		mov w cs:Screen_Y,0	;

		call Move_Window	; Place the window

		ret			; Done

; Show the player

Show_Player:	mov ax,cs:PLayer_dX	; Moving ?
		cmp ax,0		; 
		jz SP_NodX		; No, skip

		; Yes, set the direction flag

		mov al,0		; Assume left

		test ah,080h		; +/- ?
		jnz SP_GotdX		; -ve, skip

		mov al,1		; Right

SP_GotdX:	mov cs:Player_Dirn,al	; Save the dirn flag

SP_NodX:	mov cl,cs:Player_Dirn	; Get the dirn

		mov bx,cs:Player_X	; Get the player X
		mov dx,cs:Player_Y	; Y
		sub dx,3		;

		mov ax,bx		; Sprite
		shr ax,1	
		shr ax,1
		shr ax,1

		and ax,03h
		inc ax

		cmp cl,0		; Left ?
		jne SP_Draw

		add al,10		; Next set

SP_Draw:	add al,65		; Offset to first non-background

		jmp Draw_Sprite		; Draw it

; Move the player		

Move_Player:	mov bl,0		; Clear the flags

		; Jump ?

		call far ptr Test_Up	; Jump ?
		jz MP_NJ		; No, skip

		or bl,pfJump		; Set the flag

MP_NJ:		call far ptr Test_Left	; Move left ?
		jz MP_NL		; No, skip

		or bl,pfLeft		; Set the flag

MP_NL:		call far ptr Test_Right	; Move right ?
		jz MP_NR		; No, skip

		or bl,pfRight		; Set the flag

		; We have the flags for left/right/jump

MP_NR:		mov bh,cs:Player_OK	; Get the old keys
		mov cs:Player_OK,bl	; Save them

		xor bh,bl		; Set the changed flags

		; BH = changed key flags

		mov al,bl		; Get the left/right flags
		and al,pfLR		;

		mov cx,+Player_X_Step	; Assume right
		cmp al,pfRight		; Right ?
		jz MP_GotdX		; Yes, skip

		mov cx,-Player_X_Step	; Assume left
		cmp al,pfLeft		; Left ?
		jz MP_GotdX		; Yes, skip

		mov cx,0		; No X step

		; cx = -1/0/+1

MP_GotdX:	mov cs:Player_dX,cx	; Save move

		mov al,cs:Player_YF	; Get the state value
		cmp al,0		; Standing ?
		je vMP_Stand		; Yes, skip

		cmp al,1		; Rising ?
		je MP_Rise		; Yes, skip

		; Falling

MP_Fall:	mov cx,cs:Player_dY	; dY

	; We are jumping, apply gravity

MP_Got_dY:	test bl,pfJump		; Still pressed ?
		jne MP_GY_1		; Yes, skip

		add cx,Player_Grav_1	; Extra

MP_GY_1:	add cx,Player_Grav	; Step the dY

		; Clip and save the Y-Step

		cmp cx,7*256		; In range ?
		jl MP_GdY1		; Yes, skip

		mov cx,7*256		; Clip it

MP_GdY1:	mov cs:Player_dY,cx	; Now, can we do this move ?

MP_No_dY:	call Player_Test_X	; Is the X-step OK ?
		jnc MP_X_Ok		; Yes, do it

		mov w cs:Player_dX,0	; Clear the X-step

MP_X_Ok:	call Player_Test_Y	; Is the Y-step OK ?
		jnc MP_Y_Ok		; Yes, do it

		mov w cs:Player_dY,0	; Clear the Y-step
		mov b cs:Player_YF,0	; Standing

		; Move the Y to the top of the block

		sub ax,15		; Allow for the bit below the middle
		mov cs:Player_Y,ax	; Force to the right pixel

		; We have the move, do it

MP_Y_Ok:	mov ax,cs:Player_dX	; X-step
		add cs:Player_X,ax	;

		mov cx,cs:Player_dY	; Y-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cs:Player_fY,cl	; 24-bit add
		adc cs:Player_Y,ax	; Accumulate the Y

		; Now, should we move the window ?

		call Move_Window	; Move it (if we must)

		; Now, test if we should fire

		jmp Player_Fire		; kip

vMP_Stand:	jmp s MP_Stand		; Vector

MP_Set_Rise:	mov b cs:Player_YF,1	; Rising

		jmp s MP_Got_dY		; Skip

	; Rising

MP_Rise:	test b cs:Player_dY+1,80h ; -ve ?
		jne MP_Fall		  ; No, skip

MP_Set_Fall:	mov b cs:Player_YF,2	; Falling

		mov cx,0		; Not moving yet
		jmp s MP_Got_dY		; Skip

	; We are not moving in Y, is there something below us ?

MP_Stand:	push bx			; Save

		; We are stat. / falling

		mov bx,cs:Player_Y	; Accumulate the Y
		add bx,15		; Point at the feet
		mov dl,bl		; Save the offset into the block

		mov ax,cs:Player_X	; Get the X
		sub ax,8		; LHS

		mov cx,ax		; RHS
		add cx,14		;

		call Check_Floor	; Are we standing on anything ?

		pop bx			; Restore

		jnc MP_Set_Fall		; No, fall

		; Is the jump button pressed ?

		test bh,pfJump		; Has it changed ?
		je vMP_No_dY		; No, skip

		test bl,pfJump		; Jumping ?
		je vMP_No_dY		; No, skip

		; Jump

		mov cx,Jump_dY		; Assume jumping

		jmp s MP_Set_Rise	; Start to rise

vMP_No_dY:	jmp MP_No_dY		; Vector

; Can we move in X ?

Player_Test_X:	mov ax,cs:Player_dX	; Get the current dX
		cmp ax,0		; Any ?
		je PTX_X		; No, skip

		; Yes, +/- ?

		jns PTX_R		; Skip if moving right

		sub ax,8		; Left
		jmp s PTX_1		; Skip

PTX_R:		add ax,8		; Right

PTX_1:		mov bx,cs:Player_X	; Get the old X
		add ax,bx		; Get the new X

		; Is this the same block ?

		xor bx,ax		; Get any different bits
		and bl,0F0h		; Different block ?
		je PTX_X		; No, exit

		; Different. Get a pointer to the appropriate block.

		mov bx,cs:Player_Y	; Get the Y
		sub bx,14		; Up

		; Get a pointer to this block

		push ax			; Save X
		push bx			; Y

		call Calc_pMap		; Point at this block
		mov si,ax		; Get it

		pop bx			; Restore Y
		pop ax			; X

		jc PTX_Solid		; Solid

		; Now, try down

		add bx,14+14		; Move down

		call Calc_pMap		; Point at this block
		jc PTX_Solid		; Solid

		mov bx,ax		; Save the ptr

		; Loop examining blocks until a solid one found

PTX_Lp:		test w cs:[si],0100h	; Solid ?
		jne PTX_Solid		; No, skip

		cmp si,bx		; Done ?
		je PTX_X		; Yes, skip

		add si,128*2		; Move down

		jmp s PTX_Lp		; Loop

	; Solid, return CF

PTX_Solid:	stc			; Solid
		ret			;

PTX_X:		clc			; Clear
		ret			;

; Can we move in Y ? (return ax = Y of the block we hit if failed)

Player_Test_Y:	mov ax,cs:Player_dY	; Which way are we going ?
		cmp ax,0		;
		js PT_Yes		; Up, ok

		; We are stat. / falling

		mov cx,cs:Player_dY	; Y-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cl,cs:Player_fY	; 24-bit add
		adc ax,cs:Player_Y	; Accumulate the Y

		mov bx,ax		; Get the Y
		add bx,15		; Point at the feet
		mov dl,bl		; Save the offset into the block

		mov ax,cs:Player_X	; Get the X
		sub ax,8		; LHS

		mov cx,ax		; RHS
		add cx,14		;

		call Check_Floor	; Are we standing on anything ?
		ret			; Done

	; We can fall through this block

PT_Yes:		clc			; Yes
		ret			;

; Given ax = LHS, cx = RHS and bx = Y check if solid and return ax = Y of top

CF_Fail:	stc			; Failure
		mov ax,63*16		; Dummy top
		ret			; Done

Check_Floor:	mov bp,ax		; Save the LHS
		and bp,000Fh		; 0 to 15
		add bp,bp		; * 2

		sub cx,ax		; dh = Width
		mov dh,cl		;

		mov dl,al		; X-Offset
		not dl			; Invert
		and dl,0Fh		; 15 .. 0
		inc dl			; 16 .. 1

		push bx			; Save
		call Calc_pMap		; Point at the LHS block
		pop bx			; Restore
		jc CF_Fail		; Out-of-range, skip

		mov si,ax		; Save the ptr

		; Now, setup the offset into this block

		mov cl,17		; Offset = illegal
		mov ch,bl		; Y-Offset
		and ch,0Fh		; 0 .. 15

		; Now, scan all the relevant blocks

CF_Scan_Next_B:	mov ax,cs:[si]		; LHS block
		test ax,0100h		; Solid ?
		jnz CFSB_Top		; Yes, skip

		and ax,007Fh		; 0 .. 127

		add ax,ax		; * 2

		add ax,o Block_pHeights	; Look-up the heights

		mov di,ax		; Point at the block-pixel height data
		mov di,cs:[di]		; Point at the defn
		add di,bp		; Offset for X

		; Now, scan across this block looking at the thickness/height

CF_Scan_Block:	mov ax,cs:[di]		; Get the min/max
		inc di			;
		inc di			;

		; Check it

		cmp al,ch		; Are we above the bottom of the solid ?
		jbe CFSB_1		; No, we are below, ignore this

		cmp ah,cl		; Are we already above the top of it ?
		jae CFSB_1		; Yes, skip

		mov cl,ah		; New height

		cmp ah,0		; Up a block ?
		je CFSB_X		; Yes

		; Next pixel

CFSB_1:		dec dh			; One less
		jz CFSB_X		; Done, skip

		dec dl			; Loop across this block
		jnz CF_Scan_Block	;

		; Next block to the right

		inc si			; Skip one block
		inc si			;

		mov bp,0		; Offset into block

		jmp s CF_Scan_Next_B	; Move right

	; Assume top of block

CFSB_Top:	mov cl,1		; Top
		
	; Now, what was the highest

CFSB_X:		dec cl			; -1 .. 15

		cmp cl,16		; Didn't hit anything . . .
		je CF_Clear		; No, skip

		; We hit something, return the highest point

		mov ax,si		; Calc Y of the top of the block

		sub ax,o Map		;
		mov al,ah		; /256
		mov ah,0		;

		add ax,ax		; * 16
		add ax,ax		;
		add ax,ax		;
		add ax,ax		;

		xchg ax,cx		; Swap

		cbw			; 16-bit offset
		add ax,cx		; Move down/Up

		stc			; Solid
		ret			;

CF_Clear:	clc			; Not solid
		ret			;

; Given ax = X, bx = Y return bx = pBlock

Calc_pMap:	cmp bx,64*16		; Out-of-range ?
		jae CpM_F		; Yes, skip

		cmp ax,128*16		; Out-of-range ?
		jae CpM_F		; Yes, skip

		shr bx,1		; /16
		shr bx,1		;
		shr bx,1		;
		shr bx,1		;

		mov bh,bl		; Y * 128 * 2
		mov bl,0		;

		shr ax,1		; X/16
		shr ax,1		;
		shr ax,1		;
		shr ax,1		;

		add ax,ax		; * 2

		add ax,o Map		; Add base

		add ax,bx		; Add X

		ret			; Done (nc)

CpM_F:		stc			; Fail (c)
		ret			;

; Move the window

Move_Window:	mov ax,cs:Player_X	; Get the screen X
		sub ax,cs:Screen_X	; Is the player > this ?

		cmp ax,View_XO		; <LHS ?
		jb MW_LHS		; No, move the view

		cmp ax,View_Width-View_XO ; In the middle ?
		ja MW_RHS		; No, move the view

		; Now check Y

MW_XD:		mov ax,cs:Player_Y	; Get the screen Y
		sub ax,cs:Screen_Y	; Is the player > this ?

		cmp ax,View_YO		; <TOP ?
		jb MW_TOP		; No, move the view

		cmp ax,View_Height-View_YO ; In the middle ?
		ja MW_BOTT		; No, move the view

		; We are in the window, clip to the map-edges

MW_YD:		mov ax,cs:Screen_X	; Giz the X
		mov bx,cs:Screen_Y	; And Y

		cmp ax,0		; -ve ?
		jns MW_X1		; No, skip

		mov ax,0		; Clip to the LHS

MW_X1:		cmp ax,128*16-View_Width; RHS ?
		jb MW_X2		; No,skip

		mov ax,128*16-View_Width; Clip to the TOP

MW_X2:		cmp bx,0		; -ve ?
		jns MW_Y1		; No, skip

		mov bx,0		; Clip to the BOTT

MW_Y1:		cmp bx,64*16-View_Height; BOTT ?
		jb MW_Y2		; No,skip

		mov bx,64*16-View_Height; Clip to the BOTT

MW_Y2:		; Save the new (possibly) window

		mov cs:Screen_X,ax	; Save the X
		mov cs:Screen_Y,bx	; And the Y

		ret			; Done

	; We are off the LHS, move the view

MW_LHS:		mov ax,cs:Player_X	; Get the Players' X
		sub ax,View_XO		; Offset
		mov cs:Screen_X,ax	; Save it

		jmp s MW_XD		; Skip

	; We are off the RHS, move the view

MW_RHS:		mov ax,cs:Player_X	; Get the Players' X
		sub ax,View_Width-View_XO; Offset
		mov cs:Screen_X,ax	; Save it

		jmp s MW_XD		; Skip

	; We are off the TOP, move the view

MW_TOP:		mov ax,cs:Player_Y	; Get the Players' Y
		sub ax,View_YO		; Offset
		mov cs:Screen_Y,ax	; Save it

		jmp s MW_YD		; Skip

	; We are off the BOTTOM, move the view

MW_BOTT:	mov ax,cs:Player_Y	; Get the Players' X
		sub ax,View_Height-View_YO; Offset
		mov cs:Screen_Y,ax	; Save it

		jmp s MW_YD		; Skip

; Fixed data

Block_pHeights	dw bhFree,bhFree,bhFree,bhFree	; 0 - 3
		dw bhFree,bhFree,bhFree,bhFree	; 4 - 7
		dw bhFree,bhFree,bhFree,bhFree	; 8 - B
		dw bhFree,bhFree,bhFree,bhFree	; C - F

		dw bhTop			; Flat

		dw bhL_45,bhR_45		; Slopes
		dw bhL_45_B,bhR_45_B		; Slope ends

		dw bhLump			; Lump
		dw bhTop,bhTop			; Flat ends

		dw bhFree,bhFree,bhFree,bhFree	; 18 - 1B
		dw bhFree,bhFree,bhFree,bhFree	; 1C - 1F

		dw bhFree,bhFree,bhFree,bhFree	; 20 - 23
		dw bhFree,bhFree,bhFree,bhFree	; 24 - 27
		dw bhFree,bhFree,bhFree,bhFree	; 28 - 2B
		dw bhFree,bhFree,bhFree,bhFree	; 2C - 2F

		dw bhFree			; 30
		dw bhL_45,bhR_45		; Slopes
		dw bhTop,bhTop			; Flat ends

		dw bhR_45_B,bhL_45_B		; Slope ends

		dw bhFree			; 34 - 37
		dw bhFree,bhFree,bhFree,bhFree	; 38 - 3B
		dw bhFree,bhFree,bhFree,bhFree	; 3C - 3F

		dw 128 dup (bhFree)

; A free block with no solid bits

bhFree		db 0,17,0,17,0,17,0,17	; 00
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;

; A solid top/lhs

bhTop		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;

; A floating lump

bhLump		db 9,4,9,3,9,3,9,2	;
		db 9,2,9,1,9,1,9,1	;
		db 9,1,9,1,9,1,9,1	;
		db 9,2,9,2,9,3,9,4	;

; LHS slope

bhL_45		db 9,1,10,2,11,3,12,4	;
		db 13,5,14,6,15,7,15,8	;
		db 15,9,15,10,15,11,15,12;
		db 16,13,16,14,16,15,16,16;

; LHS tiny bit

bhL_45_B	db 0,17,0,17,0,17,0,17	; 00
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,8,0,8,0	; These 00's make it move up

; RHS slope

bhR_45		db 16,16,16,15,16,14,16,13;
		db 15,12,15,11,15,10,15,9;
		db 15,8,15,7,14,6,13,5	;
		db 12,4,11,3,10,2,9,1	;

; RHS tiny bit

bhR_45_B	db 8,0,8,0,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;
		db 0,17,0,17,0,17,0,17	;

; Vars

Player_X	dw ?			; The player's X
Player_Y	dw ?			; The player's Y
Player_dX	dw ?			; The player's dX
Player_dY	dw ?			; The player's dY

Player_Dirn	db 0			; 0 = left 1 = right

Player_YF	db ?			; 0 = stand, 1 = jump 2 = fall
Player_fY	db ?			; Fractional Y
Player_OK	db ?			; Old key states

