; Init the sheet

Init_Sheet:	mov cs:Sheet_No,al	; Save the new sheet number

		; Now, get the map, sprites

		call Read_Files		; Read them
		jc IS_Fail		; Can't, fail

		; Now, get the colours from the block defn into the palette

		mov si,o Pal_Defn	; From the sprite file
		mov di,o Palette	; Write it to here

		mov cx,256*3		; This many

IS_Copy_Lp:	mov al,cs:[si]		; Read it
		inc si			;

		mov cs:[di],al		; Write it
		inc di			;

		loop IS_Copy_Lp		; Loop

		; Done

		clc			; Ok

IS_Fail:	ret			; Done

; Load the files for a given sheet cs:Sheet

Read_Files:	mov al,cs:Sheet_No	; Giz the sheet number
		mov bx,o Map_FNs	; The map names
		call Find_String	; Find the string

		mov dx,bx		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		mov bx,o Map		; Point at the map
		mov cx,128*64*2		; Length

		push cs			; Data seg
		pop es			;

		call far ptr F_Read_File; Read it
		jc RF_Fail		; Can't, exit

		; Mask the file

		mov bx,o Map		; Point at it
		mov cx,128*64		;

RF_Mask:	mov ax,cs:[bx]		; Get it
		cmp ax,0130h		; Solid blank ?
		jne RFM_1		; No, skip

		mov ax,0030h
;		mov cs:[bx],ax		; Save it

RFM_1:		add bx,2		; Skip
		loop RF_Mask		; Mask it

		; Now, read the sprites

		call Release_Sprites	; Release the sprite-memory
		jc RF_Fail		; Can't, error

		; Now, read them

		call Read_Sprites	; Get them
		jc RF_Fail		; Can't, exit

		; Now, read the objects

		mov al,cs:Sheet_No	; Giz the sheet number
		mov bx,o Object_FNs	; The map names
		call Find_String	; Find the string

		mov dx,bx		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		mov bx,o Objects	; Point at the objects
		mov cx,8192		; Length

		push cs			; Data seg
		pop es			;

		call far ptr F_Read_File; Read it
		jc RF_Fail		; Can't, exit

		clc			; Ok

RF_Fail:	ret			; Done

; Release the sprite-ram

Release_Sprites:mov ax,cs:Sprite_F_Base	; Get the ptr
		cmp ax,0		; None ?
		jz RS_X			; None, skip

		mov es,ax		; Point at it

		mov ah,Deallocate_Mem	; Release it
		int dos			;

RS_X:		ret			; Done

; Read the sprite-ptrs, allocate some memory and read the sprite-data

Read_Sprites:	mov al,cs:Sheet_No	; Giz the sheet number
		mov bx,o Sprite_FNs	; The sprite names
		call Find_String	; Find the string

		mov dx,bx		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		push cs			; Into the code-seg
		pop es			;

		mov bx,o Sprite_Ptrs	; Point at the buffer
		mov cx,(255*2+2) + 256*3; Length of the ptrs + length of file

		call far ptr F_Read_File; Read it
		jc RF_Fail		; Can't, exit

		; Now, we must allocate the appropriate amount of memory

		mov bx,cs:Sprite_F_Length ; Length of the file (paras)

		; Allocate this much

		mov ah,Allocate_Mem	; Call DOS
		int dos			;
		jc RF_Fail		; Exit

		mov cs:Sprite_F_Base,ax	; Save this buffer

		; Now, we must read the sprite bit of the file

		mov al,cs:Sheet_No	; Giz the sheet number
		mov bx,o Sprite_FNs	; The sprite names
		call Find_String	; Find the string

		mov dx,bx		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		mov cx,cs:Sprite_F_Length ; Length of the file (paras)
		mov ax,0		  ;

		add cx,cx		; ax:cx * 16
		adc ax,ax		;

		add cx,cx		;
		adc ax,ax		;

		add cx,cx		;
		adc ax,ax		;

		add cx,cx		;
		adc ax,ax		;

		mov cs:WF_Len,cx	; Save the length
		mov cs:WF_Len_H,ax	;

		mov cx,00h		; File attribute

		mov al,0		; Read only

		mov ah,OpenFile		; Call dos
		int dos			;

		jc PRF_Exit		; Can't open file

		mov cs:TempHandle,ax	; Save the handle

		; Rewind to start of the data

		mov cx,0		; Point at the data
		mov dx,0500h		;

		mov bx,ax		; Handle

		mov al,0		;

		mov ah,MovePointer	;
		int dos			;

		; Read the file, 32K at a time, until the last block

		mov ax,cs:Sprite_F_Base	; Segment
		mov ds,ax		;

RS_Lp:		mov cx,cs:WF_Len	; Get the remaining size
		mov ax,cs:WF_Len_H	;

		cmp ax,0		; >=64K ?
		jnz RS_32K		; Yes, read 32K

		; Less than 64K

		cmp cx,0		; 0 ?
		je RS_Done		; Yes, exit

		; We can read this, flag done

		mov w cs:WF_Len,0	; Clear the size

		jmp s RS_Block		; Read a block

	; Read 32K

RS_32K:		sub cx,08000h		; 32K less
		sbb ax,0		;

		mov cs:WF_Len,cx	; Save the new length
		mov cs:WF_Len_H,ax	;

		; Read 32K

		mov cx,08000h		; 32K block

		; Read a block

RS_Block:	mov bx,0		; Offset

		call Read_Block		; Write it

		; Move the segment 32K

		mov ax,ds		; Move the segment
		add ax,08000h/16	; 32K
		mov ds,ax		;

		jmp s RS_Lp		; Loop

	; Close the file

RS_Done:	push ax			; Save error code

		mov bx,cs:TempHandle	; Close it
		mov ah,CloseFile	;
		int dos			;

		pop ax			;

		; Done

PRF_Exit:	ret			; Done

; Read block ds:bx for length cx

Read_Block:	push ax			; Save reg
		push dx			;

		mov dx,bx		; Get ptr

		mov bx,cs:TempHandle	; Get file handle

		mov ah,ReadFromFile	; Read it
		int dos			;
		jc RB_Fail		; Fail

		cmp ax,cx		; Save full length ?
		jz RB_OK		; Yes, skip

		stc			; Assert fail

RB_Fail:	pop dx			; Restore
		pop ax			; dummy

		mov al,64		; "Disc full"

		ret			;

RB_OK:		pop dx			; Restore
		pop ax			;

		ret			;

; Save the edited map

Write_Files:	mov al,cs:Sheet_No	; Giz the sheet number
		mov bx,o Map_FNs	; The map names
		call Find_String	; Find the string

		mov dx,bx		; Get the ^string

		push cs			; ds:dx
		pop ds			;

		mov bx,o Map		; Point at the map
		mov cx,128*64*2		; Length

		push cs			; Data seg
		pop es			;

		call far ptr F_Write_File; Write it

		ret			; Done

; Given a set of strings at cs:bx, find the al'th string and return is as cs:bx

Find_String:	cmp al,0		; First ?
		je FS_X			; Yes, skip

FS_Lp:		mov ah,cs:[bx]		; Get the next char
		inc bx			; Skip

		cmp ah,0		; End ?
		jnz FS_Lp		; No, loop

		dec al			; This one ?
		jnz FS_Lp		; No, loop

FS_X:		ret			; Done

; Fixed data

	ifndef flat_files

Map_FNs		db "gamecode\S_SALAD1.MP0",0
		db "GAMECODE\S_SALAD1.MP1",0
		db "GAMECODE\S_SALAD1.MP2",0
		db "GAMECODE\S_SALAD1.MP3",0
		db "GAMECODE\S_SALAD1.MP4",0
		db "GAMECODE\S_SALAD1.MP5",0
		db "GAMECODE\S_SALAD1.MP6",0
		db "GAMECODE\S_SALAD1.MP7",0

Sprite_FNs	db "gamecode\S_SALAD1.SP0",0
		db "GAMECODE\S_SALAD1.SP1",0
		db "GAMECODE\S_SALAD1.SP2",0
		db "GAMECODE\S_SALAD1.SP3",0
		db "GAMECODE\S_SALAD1.SP4",0
		db "GAMECODE\S_SALAD1.SP5",0
		db "GAMECODE\S_SALAD1.SP6",0
		db "GAMECODE\S_SALAD1.SP7",0

Object_FNs	db "gamecode\S_SALAD1.OB0",0
		db "GAMECODE\S_SALAD1.OB1",0
		db "GAMECODE\S_SALAD1.OB2",0
		db "GAMECODE\S_SALAD1.OB3",0
		db "GAMECODE\S_SALAD1.OB4",0
		db "GAMECODE\S_SALAD1.OB5",0
		db "GAMECODE\S_SALAD1.OB6",0
		db "GAMECODE\S_SALAD1.OB7",0

	else

Map_FNs		db "S_SALAD1.MP0",0
		db "S_SALAD1.MP1",0
		db "S_SALAD1.MP2",0
		db "S_SALAD1.MP3",0
		db "S_SALAD1.MP4",0
		db "S_SALAD1.MP5",0
		db "S_SALAD1.MP6",0
		db "S_SALAD1.MP7",0

Sprite_FNs	db "S_SALAD1.SP0",0
		db "S_SALAD1.SP1",0
		db "S_SALAD1.SP2",0
		db "S_SALAD1.SP3",0
		db "S_SALAD1.SP4",0
		db "S_SALAD1.SP5",0
		db "S_SALAD1.SP6",0
		db "S_SALAD1.SP7",0

Object_FNs	db "S_SALAD1.OB0",0
		db "S_SALAD1.OB1",0
		db "S_SALAD1.OB2",0
		db "S_SALAD1.OB3",0
		db "S_SALAD1.OB4",0
		db "S_SALAD1.OB5",0
		db "S_SALAD1.OB6",0
		db "S_SALAD1.OB7",0

	endif

; Vars

WF_Len		dw ?			; Length
WF_Len_H	dw ?			; Length high word
WF_Seg		dw ?			; Segment

TempHandle	dw ?			; The file-handle
