iA		equ 65
iDigs		equ iA + 26*2
iBlank		equ iDigs + 10
iQuote		equ iBlank + 1
iDQuote		equ iQuote + 1
iMinus		equ iDQuote + 1
iComma		equ iMinus + 1
iFStop		equ iComma + 1
iExclaim	equ iFStop + 1
sPL_Legs	equ iExclaim + 1
sPL_Top		equ sPL_Legs+18*2
sPL_Jump	equ sPL_Top+2
sPL_Jump2	equ sPL_Jump+2
sPL_Fall	equ sPL_Jump2+2
sPL_Fall2	equ sPL_Fall+2
iBlobs		equ sPL_Fall2+2
iFire		equ iBlobs+3
iExpl		equ iFire+14
iBeam		equ iExpl+14
iCross		equ iBeam+8
iCentre		equ iCross+1
iLink		equ iCentre+1
iPlat		equ iLink+1
iPlat1		equ iPlat+1
iPlat2		equ iPlat1+1
iPlat3		equ iPlat2+1
iRobot1		equ iPlat3+1
iFly1		equ iRobot1+1
iFly2		equ iFly1+1
iTest		equ iFly2+1
;iMark		equ iTest+1

iEye		equ iFly2+1
iEye_H		equ iEye+1
iEye_C		equ iEye_H+1
iCornea		equ iEye_C+1
iPupil		equ iCornea+1

iThgt0		equ iPupil+1

iWind		equ iThgt0+1
iWind1		equ iWind+1
iInvs		equ iWind1+1

; Show a sprite al at X = bx Y = dx
; al <> 0 on exit = drawn

Draw_Sprite:	; On screen ?

		sub bx,cs:Screen_X	; Calc the X wrt the LHS
		cmp bx,-23		; >-24 ?
		jl DS_X			; Out-of-range, skip

		cmp bx,View_Width+23	; <RHS ?
		jg DS_X			; Yes, skip

		; Now, is the Y in range ?

		sub dx,cs:Screen_Y	; Calc the Y wrt the TOP
		cmp dx,-23		; >-24 ?
		jl DS_X			; Out-of-range, skip

		cmp dx,View_Height+23	; <Bottom ?
		jg DS_X			; Yes, skip

		; Valid sprite ?

		sub al,1		; Valid sprite-no ? (1 .. 255)
		jc DS_X			; No, exit

		; We have to draw this, setup the RETF

		pop di			; Giz the return address
		push cs			; Save the seg
		push di			; Save the offset

		; We now have a far-return

		mov ah,0		; 16-bit
		add ax,ax		;
		mov di,ax		; Point into the table

		mov ax,cs:Sprite_Ptrs[di]; Get the segment offset
		add ax,cs:Sprite_F_Base	; Index into the code
		push ax			;

		push w 0		; IP

		; We can now start the sprite-code with a RETF

		mov ax,dx		; Get the Y
		mov cx,X_Step		; Scale it
		imul cx			;

		add ax,bx		; Calc the address
		add ax,Buff_Offset	;
		mov di,ax		; Into DI

		; Start the code

		retf			; "CALL" the sprite

; Failure vector, placed here because of the shitty short branches

DS_X:		mov al,0		; Not drawn
		ret			; Exit

; Show a crystal ball at X = bx Y = dx
; al <> 0 on exit = drawn

Draw_Ball:	; On screen ?

		sub bx,cs:Screen_X	; Calc the X wrt the LHS
		cmp bx,-8		; >-8
		jl DS_X			; Out-of-range, skip

		cmp bx,View_Width+8	; <RHS ?
		jg DS_X			; Yes, skip

		; Now, is the Y in range ?

		sub dx,cs:Screen_Y	; Calc the Y wrt the TOP
		cmp dx,-8		; >-8 ?
		jl DS_X			; Out-of-range, skip

		cmp dx,View_Height+8	; <Bottom ?
		jg DS_X			; Yes, skip

		; We have to draw this, calc the ptr

		mov ax,dx		; Get the Y
		mov cx,X_Step		; Scale it
		imul cx			;

		add ax,bx		; Calc the address
		add ax,Buff_Offset	;
		mov di,ax		; Into DI

		; Now, get the background data

		mov ax,-(X_Step*3+1)[di]; Top-line, 1
		mov cs:Mag_0,ax		;
		mov al,-(X_Step*3)+1[di];
		mov cs:Mag_1,al		;

		mov ax,-(X_Step*2+2)[di]; Line 1
		mov cs:Mag_2,ax		;
		mov ax,-(X_Step*2)[di]	;
		mov cs:Mag_3,ax		;
		mov al,-(X_Step*2)+2[di];
		mov cs:Mag_4,al		;

		mov ax,-(X_Step*1+3)[di]; Line 2
		mov cs:Mag_5,ax		;
		mov ax,-(X_Step*1+1)[di];
		mov cs:Mag_6,ax		;
		mov ax,-(X_Step*1)+1[di];
		mov cs:Mag_7,ax		;
		mov al,-(X_Step*1)+3[di];
		mov cs:Mag_8,al		;

		mov ax,-3[di]		; Line 3
		mov cs:Mag_9,ax		;
		mov ax,-1[di]		;
		mov cs:Mag_10,ax	;
		mov ax,1[di]		;
		mov cs:Mag_11,ax	;
		mov al,3[di]		;
		mov cs:Mag_12,al	;

		mov ax,(X_Step*1-3)[di]	; Line 4
		mov cs:Mag_13,ax	;
		mov ax,(X_Step*1-1)[di]	;
		mov cs:Mag_14,ax	;
		mov ax,(X_Step*1)+1[di]	;
		mov cs:Mag_15,ax	;
		mov al,(X_Step*1)+3[di]	;
		mov cs:Mag_16,al	;

		mov ax,(X_Step*2-2)[di]	; Line 5
		mov cs:Mag_17,ax	;
		mov ax,(X_Step*2)[di]	;
		mov cs:Mag_18,ax	;
		mov al,(X_Step*2)+2[di]	;
		mov cs:Mag_19,al	;

		mov ax,(X_Step*3-1)[di]	; Line 6
		mov cs:Mag_20,ax	;
		mov al,(X_Step*3)+1[di]	;
		mov cs:Mag_21,al	;

		; Now, write it

		mov ax,cs:Mag_0		; Top line
		mov -(X_Step*6)-2[di],al;

		mov al,ah		; Dup
		mov -(X_Step*6)-1[di],ax;
		mov -(X_Step*6)+1[di],al;

		mov al,cs:Mag_1		;
		mov -(X_Step*6)+2[di],al;

		; Line 1

		mov ax,cs:Mag_2		; Line 1
		mov -(X_Step*5)-4[di],al;
		mov -(X_Step*4)-5[di],al;
		mov -(X_Step*4)-4[di],al;

		mov al,ah		; Dup
		mov -(X_Step*5)-3[di],ax;
		mov -(X_Step*4)-3[di],ax;

		mov al,b cs:Mag_3	;
		mov ah,al		;

		mov -(X_Step*5)-1[di],ax;
		mov -(X_Step*4)-1[di],ax;
		mov -(X_Step*5)+1[di],al;
		mov -(X_Step*4)+1[di],al;

		mov al,b cs:Mag_3+1	;
		mov ah,al		;

		mov -(X_Step*5)+2[di],ax;
		mov -(X_Step*4)+2[di],ax;

		mov al,cs:Mag_4		;
		mov ah,al		;

		mov -(X_Step*4)+4[di],ax;
		mov -(X_Step*5)+4[di],al;

		; Line 2

		mov ax,cs:Mag_5		; Line 2
		mov -(X_Step*2)-6[di],al;

		mov al,ah		; Dup
		mov -(X_Step*2)-5[di],ax;
		mov -(X_Step*3)-5[di],ax;

		mov al,b cs:Mag_6	;
		mov ah,al		; Dup

		mov -(X_Step*2)-3[di],ax;
		mov -(X_Step*3)-3[di],ax;

		mov al,b cs:Mag_6+1	;
		mov ah,al		; Dup

		mov -(X_Step*2)-1[di],ax;
		mov -(X_Step*3)-1[di],ax;
		mov -(X_Step*2)+1[di],al;
		mov -(X_Step*3)+1[di],al;

		mov al,b cs:Mag_7	;
		mov ah,al		; Dup

		mov -(X_Step*2)+2[di],ax;
		mov -(X_Step*3)+2[di],ax;

		mov al,b cs:Mag_7+1	;
		mov ah,al		; Dup

		mov -(X_Step*2)+4[di],ax;
		mov -(X_Step*3)+4[di],ax;

		mov al,cs:Mag_8		;
		mov -(X_Step*2)+6[di],al;

		; Line 3

		mov ax,cs:Mag_9		; Line 3
		mov -(X_Step*1)-6[di],al;
		mov -6[di],al		;
		mov  (X_Step*1)-6[di],al;

		mov al,ah		; Dup
		mov -(X_Step*1)-5[di],ax;
		mov -5[di],ax		;
		mov  (X_Step*1)-5[di],ax;

		mov al,b cs:Mag_10	;
		mov ah,al		; Dup

		mov -(X_Step*1)-3[di],ax;
		mov            -3[di],ax;
		mov  (X_Step*1)-3[di],ax;

		mov al,b cs:Mag_10+1	;
		mov ah,al		; Dup

		mov -(X_Step*1)-1[di],ax;
		mov            -1[di],ax;
		mov  (X_Step*1)-1[di],ax;

		mov -(X_Step*1)+1[di],al;
		mov            +1[di],al;
		mov  (X_Step*1)+1[di],al;

		mov al,b cs:Mag_11	;
		mov ah,al		; Dup

		mov -(X_Step*1)+2[di],ax;
		mov            +2[di],ax;
		mov  (X_Step*1)+2[di],ax;

		mov al,b cs:Mag_11+1	;
		mov ah,al		; Dup

		mov -(X_Step*1)+4[di],ax;
		mov            +4[di],ax;
		mov  (X_Step*1)+4[di],ax;

		mov al,cs:Mag_12	;
		mov -(X_Step*1)+6[di],al;
		mov            +6[di],al;
		mov  (X_Step*1)+6[di],al;

		; Line 4

		mov ax,cs:Mag_13	; Line 4
		mov  (X_Step*2)-6[di],al;

		mov al,ah		; Dup
		mov  (X_Step*2)-5[di],ax;
		mov  (X_Step*3)-5[di],ax;

		mov al,b cs:Mag_14	;
		mov ah,al		; Dup

		mov  (X_Step*2)-3[di],ax;
		mov  (X_Step*3)-3[di],ax;

		mov al,b cs:Mag_14+1	;
		mov ah,al		; Dup

		mov  (X_Step*2)-1[di],ax;
		mov  (X_Step*3)-1[di],ax;
		mov  (X_Step*2)+1[di],al;
		mov  (X_Step*3)+1[di],al;

		mov al,b cs:Mag_15	;
		mov ah,al		; Dup

		mov  (X_Step*2)+2[di],ax;
		mov  (X_Step*3)+2[di],ax;

		mov al,b cs:Mag_15+1	;
		mov ah,al		; Dup

		mov  (X_Step*2)+4[di],ax;
		mov  (X_Step*3)+4[di],ax;

		mov al,cs:Mag_16	;
		mov  (X_Step*2)+6[di],al;

		; Line 5

		mov ax,cs:Mag_17	; Line 5
		mov (X_Step*5)-4[di],al	;
		mov (X_Step*4)-5[di],al	;
		mov (X_Step*4)-4[di],al	;

		mov al,ah		; Dup
		mov (X_Step*5)-3[di],ax	;
		mov (X_Step*4)-3[di],ax	;

		mov al,b cs:Mag_18	;
		mov ah,al		;

		mov (X_Step*5)-1[di],ax	;
		mov (X_Step*4)-1[di],ax	;
		mov (X_Step*5)+1[di],al	;
		mov (X_Step*4)+1[di],al	;

		mov al,b cs:Mag_18+1	;
		mov ah,al		;

		mov (X_Step*5)+2[di],ax	;
		mov (X_Step*4)+2[di],ax	;

		mov al,cs:Mag_19	;
		mov ah,al		;

		mov (X_Step*4)+4[di],ax	;
		mov (X_Step*5)+4[di],al	;

		; Line 6

		mov ax,cs:Mag_20	; Line 6
		mov (X_Step*6)-2[di],al	;

		mov al,ah		; Dup
		mov (X_Step*6)-1[di],ax	;
		mov (X_Step*6)+1[di],al	;

		mov al,cs:Mag_21	;
		mov (X_Step*6)+2[di],al	;

		; Start the code

		ret			; Done, exit

; Vars
		align 2

Mag_0		dw ?			;
Mag_2		dw ?			;
Mag_3		dw ?			;
Mag_5		dw ?			;
Mag_6		dw ?			;
Mag_7		dw ?			;
Mag_9		dw ?			;
Mag_10		dw ?			;
Mag_11		dw ?			;
Mag_13		dw ?			;
Mag_14		dw ?			;
Mag_15		dw ?			;
Mag_17		dw ?			;
Mag_18		dw ?			;
Mag_20		dw ?			;

Mag_1		db ?			;
Mag_4		db ?			;
Mag_8		db ?			;
Mag_12		db ?			;
Mag_16		db ?			;
Mag_19		db ?			;
Mag_21		db ?			;

		align 2

Sprite_F_Base	dw ?			; Ptr to the sprite-data
Sprite_Ptrs	dw 255 dup (?)		; Pointers to the sprite-code
Sprite_F_Length	dw 0			; The length of the file

Pal_Defn	db 256*3 dup (?)	; The palette defn

Expl_S		dw ?