; This code shows the player's status

Score_XY	equ 320*16+8		; Posn on the display
Health_Mid	equ (4+31) * 320 + 266	; Pos of middle of the LHS bar

Number_Spacing	equ 14			; Between digits

; Start the status display

Init_Status:	mov w cs:Score,0	; Reset the score

		ret			; Done

; Now, redraw it from scratch

Setup_Status:	mov ax,0A000h		; Point at the VDU
		mov ds,ax		;

		; Clear the score

		mov si,o Score_Segs	; Point at the score defn
		mov cl,5		; This many digits
		mov di,Score_XY		; Posn

		call Clear_Number	; Clear it

		; Now show the normal-state

		mov b cs:Score_Chg,1	; Flag changed

		; Setup the health status

		call Setup_Health	; Set it

		ret			; Done

; Alter the score

Add_Score:	add cs:Score,ax		; Change it

		mov b cs:Score_Chg,1	; Flag changed

		ret			; Done

; Alter the health

Add_Health:	push ax			; Save

		add al,cs:Health	; Change it

		cmp al,127		; Max ?
		jb AH_1			; No, skip

		mov al,127		; Clip it

AH_1:		mov cs:Health,al	; Store it

		pop ax			; Done
		ret			;

Sub_Health:	push ax			; Save

		sub cs:Health,al	; Change it
		jnc SH_1		; Ok, skip

		mov b cs:Health,0	; Clip it

SH_1:		pop ax			; Done
		ret			;

; Show the current status

Show_Status:	call Show_Health	; Show it

;		test b cs:Frame_No,7	; Odd/Even
;		jnz SS_Ignore		; Even, skip

		test b cs:Score_Chg,-1	; Changed ?
		jnz SS_Score		; Yes, show it

		ret			; Done

	; Even frames

SS_Ignore:	ret			; Done

	; Show the score

SS_Score:	mov ax,cs:Score		; Get the score

		mov si,o Score_Segs	; To here
		call WriteDec16		; Set the segments

		mov b cs:Score_Chg,0	; Not again

		; Now show it

		mov ax,0A000h		; Point at the VDU
		mov ds,ax		;

		mov di,Score_XY		; Point at the display
		mov si,o Score_Segs	; Point at the segment info.

		mov cl,5		; This many chars

		jmp Show_Number		; Show it

; Show a number

Show_Number:	mov ax,cs:[si]		; Get the next pair of new/old segs
		lea si,2[si]		; Skip them

		cmp al,ah		; Changed ?
		jnz SSS_Diff		; Yes, skip

SN_Next:	lea di,Number_Spacing[di] ; Skip the char

		dec cl			; Loop
		jnz Show_Number		;

		ret			; Done

	; Update a digit

SSS_Diff:	mov cs:-2[si],ah	; Update it

		xor al,ah		; Get the different segment flags

		shr ax,1		; Seg 0
		jnc SSSD_1		; No, skip

		call SSSD_Horiz		; Show it

SSSD_1:		shr ax,1		; Seg 0
		jnc SSSD_2		; No, skip

		lea di,9*320[di]	; Move down

		call SSSD_Horiz		; Show it

		lea di,-9*320[di]	; Back again

SSSD_2:		shr ax,1		; Seg 0
		jnc SSSD_3		; No, skip

		lea di,18*320[di]	; Move down

		call SSSD_Horiz		; Show it

		lea di,-18*320[di]	; Back again

SSSD_3:		shr ax,1		; Seg 0
		jnc SSSD_4		; No, skip

		call SSSD_Vert		; Show it

SSSD_4:		shr ax,1		; Seg 0
		jnc SSSD_5		; No, skip

		lea di,9[di]		; Move across

		call SSSD_Vert		; Show it

		lea di,-9[di]		; Back again

SSSD_5:		shr ax,1		; Seg 0
		jnc SSSD_6		; No, skip

		lea di,9*320[di]	; Move down

		call SSSD_Vert		; Show it

		lea di,-9*320[di]	; Back again

SSSD_6:		shr ax,1		; Seg 0
		jnc SSSD_7		; No, skip

		lea di,(9*320+9)[di]	; Move across

		call SSSD_Vert		; Show it

		lea di,-(9*320+9)[di]	; Back again

SSSD_7:		jmp s SN_Next		; Done

; Clear a number

Clear_Number:	mov w cs:[si],0000h	; Get the next pair of new/old segs
		lea si,2[si]		; Skip them

		; Clear the display

		mov ax,0		; Clear it

		call SSSD_Horiz		; Show it

		lea di,9*320[di]	; Move down

		call SSSD_Horiz		; Show it

		lea di,9*320[di]	; 

		call SSSD_Horiz		; Show it

		lea di,-18*320[di]	; Back again

		call SSSD_Vert		; Show it

		lea di,9[di]		; Move across

		call SSSD_Vert		; Show it

		lea di,9*320[di]	; Move down

		call SSSD_Vert		; Show it

		lea di,-9[di]		; Back again

		call SSSD_Vert		; Show it

		lea di,-(9*320)[di]	; Back again

		; Next digit

		lea di,Number_Spacing[di] ; Across

		dec cl			; Loop
		jnz Clear_Number	;

		ret			; Done

	; Draw the horizontal

SSSD_Horiz:	mov bx,0303h		; Assume black
		mov ch,03h		;

		test al,80h		; Shown/not
		jz SSSDH_1		; Shown

		mov bx,0504h		; Colours
		mov ch,06h		;

SSSDH_1:	mov ds:-320+2[di],bl	; Top line
		mov ds:-320+3[di],bh	;
		mov ds:-320+4[di],bh	;
		mov ds:-320+5[di],bh	;
		mov ds:-320+6[di],bh	;
		mov ds:-320+7[di],bl	;

		mov ds:1[di],bl		; Middle line
		mov ds:2[di],bh		;
		mov ds:3[di],ch		;
		mov ds:4[di],ch		;
		mov ds:5[di],ch		;
		mov ds:6[di],ch		;
		mov ds:7[di],bh		;
		mov ds:8[di],bl		;

		mov ds:320+2[di],bl	; Bottom line
		mov ds:320+3[di],bh	;
		mov ds:320+4[di],bh	;
		mov ds:320+5[di],bh	;
		mov ds:320+6[di],bh	;
		mov ds:320+7[di],bl	;

		ret			; Done

	; Draw the horizontal

SSSD_Vert:	mov bx,0303h		; Assume black
		mov ch,03h		;

		test al,80h		; Shown/not
		jz SSSDV_1		; Shown

		mov bx,0504h		; Colours
		mov ch,06h		;

SSSDV_1:	mov ds:320[di],bl	; Top line

		mov ds:640-1[di],bl	;
		mov ds:640[di],bh	;
		mov ds:640+1[di],bl	;

		mov ds:960-1[di],bh	;
		mov ds:960[di],ch	;
		mov ds:960+1[di],bh	;

		mov ds:1280-1[di],bh	;
		mov ds:1280[di],ch	;
		mov ds:1280+1[di],bh	;

		mov ds:1600-1[di],bh	;
		mov ds:1600[di],ch	;
		mov ds:1600+1[di],bh	;

		mov ds:1920-1[di],bh	;
		mov ds:1920[di],ch	;
		mov ds:1920+1[di],bh	;

		mov ds:2240-1[di],bl	;
		mov ds:2240[di],bh	;
		mov ds:2240+1[di],bl	;

		mov ds:2560[di],bl	;

		ret			; Done

; Convert a number in ax into a 5-digit buffer (si)

; Write the number

WriteDec16:	push ax			; Save regs
		push bx			;
		push di			;

		mov di,ax		; Shuffle regs

		mov bx,o PowersOfTen	; Digit values table

		mov ah,0		; To be displayed for 0

WD_Lp:		call WD_CalcDigit	; Calc digit

		cmp al,0		; Zero ?
		jnz WD_1		; No

		mov al,ah		; Print ' ' or '0'
		call Dec_Char		;

		jmp s WD_Next		; Do next digit

WD_1:		mov ah,80h		; Use '0' in future
		
		or al,ah		; Make char
		call Dec_Char		;

WD_Next:	add bx,2		; Next power of ten

		cmp w cs:[bx],1		; Last power of ten ?
		jnz WD_Lp		; No, continue

		call WD_CalcDigit	; Calc digit

		or al,80h		; Make char
		call Dec_Char		;

		pop di			; Restore
		pop bx			;
		pop ax			;

		ret			; Done
		
WD_CalcDigit:	mov al,-1		; Initial digit
	
WDCD_Lp:	inc al			; Inc digit

		sub di,CS:[bx]		; 16-bit

		jnc WDCD_Lp		; Try again

		add di,CS:[bx]		; Step back

		ret			; Done						

; Decimal char out

Dec_Char:	push ax			; Save

		mov ah,0h		; All off

		cmp al,0		; Off ?
		je DC_Set		; Yes, skip it

		; Now, look it up

		push bx			; Save

		mov bl,al		; Get the 'char'
		and bx,000Fh		; Mask

		add bx,o Seg_Tab	; Point at the table

		mov ah,cs:[bx]		; Get the segment data

		pop bx			; Restore

	; Write the segments

DC_Set:		mov cs:1[si],ah		; Write the segs
		lea si,2[si]		; Skip

		pop ax			; Restore
		ret			; Done

; Setup the health ptrs

Setup_Health:	mov di,o iHealth	; Copy it
		mov si,o Health_Ptrs	;

		mov cx,5*3		; This many

SH_Lp:		mov ax,cs:[di]		; Read
		lea di,2[di]		;

		mov cs:[si],ax		; Write
		lea si,2[si]		;

		loop SH_Lp		; Loop

		; Done

		mov b cs:Health,127	; Top

		mov ax,o Health_Ptrs	; Point at the health ptrs
		mov cs:pHPtr,ax		;

		ret			; Done

; Show the current health

Show_Health:	mov ax,0A000h		; Point at the VDU
		mov ds,ax		;

		; Get the random

		call Rand_32		; Random

		mov di,cs:pHPtr		; Point at the bar

		mov al,cs:Health	; Alive ?
		cmp al,0		;
		je ShH_Down		; No, down

		shr al,2		; Scale it

		sub al,cs:4[di]		; Giz the posn
		neg al			; Giz the displacement
		add al,al		; * 2
		cbw			; 16-bit

		mov si,o Disp_Prob	; Point at the prob. table
		add si,ax		; Point at the prob.

		mov dx,cs:[si]		; Giz the probabilities

		; Move down ?

		mov al,b cs:Cheap_Rand	; Random

		cmp al,dl		; Move down ?
		jb ShH_Down		; Yes

		cmp al,dh		; Move up ?
		ja ShH_Up		; Yes

		; Don't move, leave alone

ShH_Moved:	call Draw_Ptr		; Show one

		lea di,6[di]		; Skip

		cmp di,o Health_Ptrs+5*6; End ?
		jne ShH_Next		; Yes, skip

		mov di,o Health_Ptrs	; Point at the first

ShH_Next:	mov cs:pHPtr,di		; Point at the next one

ShH_X:		ret			; Done

	; Move Up

ShH_Up:		mov al,cs:4[di]		; Are we at the end ?
		cmp al,31		;
		jae ShH_Moved		; Yes, ignore

		inc al			; Step it
		mov cs:4[di],al		;

		sub w cs:[di],320	; Up

		jmp s ShH_Moved		; Show it

	; Move Down

ShH_Down:	mov al,cs:4[di]		; Are we at the end ?
		cmp al,0		;
		je ShH_Moved		; Yes, ignore

		dec al			; Step it
		mov cs:4[di],al		;

		add w cs:[di],320	; Up

		jmp s ShH_Moved		; Show it

; Drive the health indicators, given di = pIndicator data

Draw_Ptr:	mov ax,cs:[di]		; Get the Y
		cmp ax,cs:2[di]		; Same as old ?
		je DPtr_X		; Yes, ignore

		; Draw it

		mov cs:2[di],ax		; Save the new ptr

		mov si,ax		; Point at the display

		; Draw it

		mov al,2		; Background char

		mov [si],al		; Clear it
		mov 2*320+2[si],al	;
		mov 4*320+2[si],al	;
		mov 6*320[si],al	;

		mov ax,0209h		; Clear/Draw it
		mov 1*320[si],ax	;
		mov 5*320[si],ax	;

		mov ax,0908h		; Clear/Draw it
		mov 2*320[si],ax	;
		mov 4*320[si],ax	;

		mov 3*320+2[si],al	;
		mov ax,0707h		;
		mov 3*320[si],ax	;

DPtr_X:		ret			; Done

; Fixed

PowersOfTen	dw 10000,1000,100,10,1	; Powers for decimal print

Seg_Tab		db 1111101b		; 0
		db 1010000b		; 1
		db 0110111b		; 2
		db 1010111b		; 3
		db 1011010b		; 4
		db 1001111b		; 5
		db 1101111b		; 6
		db 1010001b		; 7
		db 1111111b		; 8
		db 1011111b		; 9

; The display probabilities

		db   0,  0		;-31
		db   0,  0		;-30
		db   0,  0		;-29
		db   0,  0		;-28
		db   0,  0		;-27
		db   0,  0		;-26
		db   0,  0		;-25
		db   0,  0		;-24
		db   0,  0		;-23
		db   0,  0		;-22
		db   0,  0		;-21
		db   0,  0		;-20
		db   0,  0		;-19
		db   0,  0		;-18
		db   0,  0		;-17
		db   0,  0		;-16
		db   0,  5		;-15
		db   0, 15		;-14
		db   0, 25		;-13
		db   0, 35		;-12
		db   0, 45		;-11
		db   0, 55		;-10
		db  10, 65		;-9
		db  20, 75		;-8
		db  30, 85		;-7
		db  40, 95		;-6
		db  50,105		;-5
		db  60,115		;-4
		db  70,125		;-3
		db  80,135		;-2
		db  40,215		;-1
Disp_Prob:	db 30,225		; 0
		db 50,235		; 1
		db 120,175		; 2
		db 130,185		; 3
		db 140,195		; 4
		db 150,205		; 5
		db 160,215		; 6
		db 170,225		; 7
		db 180,235		; 8
		db 190,245		; 9
		db 200,255		; 10
		db 210,255		; 11
		db 220,255		; 12
		db 230,255		; 13
		db 240,255		; 14
		db 250,255		; 15
		db 255,255		; 16
		db 255,255		; 17
		db 255,255		; 18
		db 255,255		; 19
		db 255,255		; 20
		db 255,255		; 21
		db 255,255		; 22
		db 255,255		; 23
		db 255,255		; 24
		db 255,255		; 25
		db 255,255		; 26
		db 255,255		; 27
		db 255,255		; 28
		db 255,255		; 29
		db 255,255		; 30
		db 255,255		; 31

; The default health states

iHealth:	dw Health_Mid,0,0	; Middle
		dw Health_Mid+10,0,0	;
		dw Health_Mid+20,0,0	;
		dw Health_Mid+30,0,0	;
		dw Health_Mid+40,0,0	;

; Vars
		align 2

Score_Segs	dw ?,?,?,?,?		; Segment flags Old/New

Health_Ptrs	dw 5*3 dup (?)		; Vars

pHPtr		dw ?			; Ptr to the next bar

Score_Chg	db ?			; NZ = changed
Health		db ?			; 0 .. 31
