; This drives the monsters about.

dt_X		equ 0			; Offsets into the thing defn
dt_Y		equ 2			;
dt_Type		equ 4			;
dt_A		equ 6			;
dt_B		equ 8			;
dt_C		equ 10			;

dt_Length	equ 18			; Length

Thing_Grav	equ 30
Thing_Jump	equ -1350

; Type	0 = Just sits there doing nothing
;	1 = L-R mover
;	2 = Jumper

; Create them to start with

Create_Things:	mov si,cs:piThings	; Point at the things
		add si,o Objects	;

		; Now, move down this list creating the things

CT_Lp:		mov bx,cs:dt_X[si]	; Get the X
		mov dx,cs:dt_Y[si]	; Y

		mov ax,bx		; End ?
		or ax,dx		;
		jz CT_X			; Yes, skip

		; Now, add this thing

		mov ax,cs:dt_Type[si]	; Get the type

		call CT_Add		; Add this thing

		; Done, loop

		lea si,dt_Length[si]	; Skip it

		jmp s CT_Lp		; Loop

CT_X:		ret			; Done

; Given bx = x; dx = y and ax = type | create a thing
; Vars at cs:[si]

CT_Add:		call Get_Free		; Giz some free space
		jc CT_X			; Failed, exit

		call Add_Thing		; Add it to the list

		; Now, set its vars

		mov cs:d_X[di],bx	; X
		mov b cs:d_frac_X[di],0	;

		mov cs:d_Y[di],dx	; Y
		mov b cs:d_frac_Y[di],0	;

		; Default vars

		sub dx,dx		; 0

		mov cs:dState[di],dl	; State := 0

		mov cs:ddX[di],dx	; Move = 0
		mov cs:ddY[di],dx	;

		mov cs:dcStep[di],dx	; Clear it

		mov b cs:dHits[di],20	; Lots

		mov cs:dFlags[di],dl	; No, 0

		; Decode the type

		cmp al,0		; Type 0 ?
		je CTA_0		; Yes, skip

		cmp al,1		; Type 1 ?
		je CTA_1		; Yes, skip

		cmp al,2		; Type 2 ?
		je CTA_2		; Yes, skip

	; Default monster

CTA_0:		mov ax,o MT_0		; Move routine
		mov cs:dpMove[di],ax	; Set it

		; This just sits there, but it's ugly all the same . . .

		mov al,cs:dt_A[si]	; Get the shape
		mov cs:dShape[di],al	; Store it

		ret			; Done

	; Moves L-R

CTA_1:		mov ax,o MT_1		; Move routine
		mov cs:dpMove[di],ax	; Set it

		; This just moves L-R

		mov al,cs:dt_A[si]	; Get the shape
		mov cs:dShape[di],al	; Store it

		mov ax,cs:dt_C[si]	; Get the speed
		mov cs:ddX[di],ax	; Store it

		mov ax,cs:dt_B[si]	; Get the movement extent
		mov cs:dnStep[di],ax	; Save it
		mov cs:dcStep[di],ax	; Save it

		ret			; Done

	; Jumps about

CTA_2:		mov ax,o MT_2		; Move routine
		mov cs:dpMove[di],ax	; Set it

		; This jumps after the player

		mov al,cs:dt_A[si]	; Get the shape
		mov cs:dShape[di],al	; Store it

;		mov ax,cs:dt_C[si]	; Get the height jumped
;		mov cs:dSize[di],ah	; Store it

		mov ax,cs:dt_B[si]	; Get the movement extent
		mov cs:dnStep[di],ax	; Save it
		mov cs:dcStep[di],ax	; Save it

		ret			; Done

; Move them

Move_Things:	mov ax,0		; Clear the lists
		mov cs:pVisible,ax	;

		mov di,cs:pThings	; Point at the thing list

		cmp di,0		; Any things ?
		jz MT_X			; No, exit

		mov ax,o pThings-dpNext	; Point at this ptr
		mov cs:pPrev_Thing,ax	; Save this

		; There are things

MT_Lp:		cmp di,0		; Valid ?
		jz MT_X			; No, skip

		; Now show this thing

		mov bx,cs:dpMove[di]	; Point at it's code
		call bx			; Move it
		jc MT_End		; Kill it, (explode)

		; Move onto the next

MT_Next:	mov cs:pPrev_Thing,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next proj

		jmp MT_Lp		; Loop

	; Exit code, setup the un-draw operation

MT_X:		ret			; Done

	; We must kill this thing

MT_End:		mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Thing	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Explode it

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s MT_Lp		; Loop

; Code to kill a thing

MT_Suicide:	stc			; Kill us
		ret			; Done

; Code to move the simple thing (0), entry with di pointing at data

MT_0:		mov al,cs:dShape[di]	; Get the shape
		mov ah,0		; Make the sprite number 16-bit

		mov bx,cs:d_X[di]	; X
		mov dx,cs:d_Y[di]	; Y

	jmp Draw_Eye

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			;

		clc			; Ok
		ret			; Done/Not shown

; Code to move L-R

MT_1:		mov ax,cs:ddX[di]	; Get the disp
		mov bl,al		; Low
		mov al,ah		;
		cbw			;

		add cs:d_frac_X[di],bl	; X
		adc ax,cs:d_X[di]	;
		mov cs:d_X[di],ax	;

		; Setup the clip-box

		sub ax,4		; 8 by 8
		mov cs:dLeft[di],ax	;

		add ax,8		; 8 by 8
		mov cs:dRight[di],ax	;

		mov ax,cs:d_Y[di]	; Y	
		sub ax,4		; 8 by 8
		mov cs:dTop[di],ax	;

		add ax,8		; 8 by 8
		mov cs:dBott[di],ax	;

		; Now, fire at the man

		mov ax,cs:Frame_No
		and al,15
		jnz MT_1a

		mov ax,122;0		; Speed
		call Fire_At_Man	; Try it

		; Now, it is moved, dec the move count

MT_1a:		dec w cs:dcStep[di]	; Dec it
		jnz MT_0		; Show it

		; Change dirn

		mov ax,cs:dnStep[di]	; Reset the count
		mov cs:dcStep[di],ax	;

		neg w cs:ddX[di]	; Flip it

		jmp s MT_0		; Show it
		
; Code to move a jumper

MT_2:		call Calc_MTP_Vect	; cx = +1/0/-1 (dx)
					; dx = +1/0/-1 (dy)

		shl cx,4		; * 256
		add cs:ddX[di],cx	;

		; Setup for platform check

		sub ax,ax		; 0
		mov cs:TT_Plat_F,al	; Assume not
		mov cs:dImpact[di],ax	; Not landed

		; Test the X/Y

		call Thing_Test_X	; Try it
		jnc MT2_X_Ok		; Yes, do it

		mov w cs:ddX[di],0	; Clear the X-step
		mov b cs:d_frac_X[di],0	;

	; Now check the Y

MT2_X_Ok:	mov al,cs:dState[di]	; Get the state

		; Apply gravity

		mov ax,Thing_Grav	; Same as player
		add cs:ddY[di],ax	; Apply it

		; Test Y

MT2_Walk:	call Thing_Test_Y	; Try it
		jnc MT2_Y_Ok		; Yes, do it

		mov w cs:ddY[di],0	; Clear the Y-step
		mov b cs:d_frac_Y[di],0	;

		mov cs:d_Y[di],ax	; Move to the top of this block . . .

		mov b cs:dState[di],0	; Flag walking

	mov w cs:ddX[di],0	; 

		; Now, have we been walking a while ?

		dec b cs:dcStep[di]	; Dec it
		jnz MT2_Y_Ok		; Don't jump yet

		; Jump now

		mov ax,cs:Cheap_Rand	; Random
		xor ax,di		; Randomize

		; Random jump

		or ah,0F8h		; Clip the range
		sub ax,400		;
		mov cs:ddY[di],ax	; Jump
		neg ax			;
		mov cs:dImpact[di],ax	; Impact

		; Random pause

		and al,03Fh
		add al,10
		mov b cs:dcStep[di],al	; Random pause

;	mov w cs:ddX[di],0

		; Move in Y

MT2_Y_Ok:	mov ax,cs:ddY[di]	; Get the disp
		mov bl,al		; Low
		mov al,ah		;
		cbw			;

		add cs:d_frac_Y[di],bl	; X
		adc cs:d_Y[di],ax	;

		; Show it

		; Assume not on a platform

		sub ax,ax		; 0
		mov cs:Plat_dX,ax	; No move
		mov cs:Plat_dY,ax	;

		; Now, if we are standing on a platform, we move with it

		test b cs:TT_Plat_F,-1	; On one ?
		jz MT2_NoPlat		; No, skip

		; Were we on one ?

		test b cs:dFlags[di],2	; Were we ?
		jz MT2_New_Plat		; No, skip

		; Yes, follow it in X

		mov ax,cs:PT_Plat_X	; New
		sub ax,cs:dPlat_X[di]	; Old

		; Is this a valid difference ?

		mov bx,ax		; Save it
		jns MT2_Plat_0		;

		neg bx			; Abs dX

MT2_Plat_0:	cmp bx,5		; < 5 ?
		jae MT2_Plat_1		; No, behave as though we were not
					; On one

		; Ok, lets assume that this is the same platform and follow it

		add cs:d_X[di],ax	; Move us

		mov ah,al		; * 256
		mov al,0		;

		mov cs:Plat_dX,ax	; Vector

		; Yes, follow it in Y

		mov ax,cs:PT_Plat_Y	; New
		mov cs:d_Y[di],ax	;

		sub ax,cs:dPlat_Y[di]	; Old

		mov ah,al		; * 256
		mov al,0		;

		mov cs:Plat_dY,ax	; Vector

		; Save to old posn

		jmp s MT2_Plat_1	; Skip

	; Just landed on one

MT2_New_Plat:	mov ax,cs:ddY[di]	; Get the impact velocity
		mov cs:dImpact[di],ax	; Set it

		; Save

MT2_Plat_1:	mov ax,cs:PT_Plat_X	; New
		mov cs:dPlat_X[di],ax	; Save it

		mov ax,cs:PT_Plat_Y	; New
		mov cs:dPlat_Y[di],ax	; Save it

		; Now same as if now on a platform

MT2_NoPlat:	mov al,cs:dFlags[di]	; Save the platform flag
		and al,0FDh		; Mask
		or al,cs:TT_Plat_F	; On one ?
		mov cs:dFlags[di],al	; Save the flag

		; Move it in X, then show it

		mov ax,cs:ddX[di]	; Get the disp
		mov bl,al		; Low
		mov al,ah		;
		cbw			;

		add cs:d_frac_X[di],bl	; X
		adc cs:d_X[di],ax	;

		; Setup the clip-box

		mov ax,cs:d_X[di]	; X
		sub ax,4		; 8 by 8
		mov cs:dLeft[di],ax	;

		add ax,8		; 8 by 8
		mov cs:dRight[di],ax	;

		mov ax,cs:d_Y[di]	; Y	
		sub ax,4		; 8 by 8
		mov cs:dTop[di],ax	;

		add ax,8		; 8 by 8
		mov cs:dBott[di],ax	;

		; Show it

		jmp Draw_Eye		; Show it


Draw_Eye:	mov ax,iCornea		; Get the shape

		mov bx,cs:d_X[di]	; X
		mov dx,cs:d_Y[di]	; Y
		sub dx,7		; Above the ground

		push di			; Save
		push dx			;
		push bx			;
		call Draw_Sprite	; Show it
		pop bx			;
		pop dx			;
		pop di			;

		cmp al,0		; Drawn ?
		jz DE_X			; Skip

		; Now, calc the pupil position

		mov ax,cs:Player_X	; Get the player's X
		sub ax,bx		; Difference

		sar ax,5		; /32
		add bx,ax		; Move it

		mov ax,cs:Player_Y	; Get the player's Y
		sub ax,dx		; Difference

		sar ax,5		; /32
		add dx,ax		; Move it

		mov ax,iPupil		; Get the shape

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			; Restore

		; Now the eye

		mov bx,cs:d_X[di]	; X
		mov dx,cs:d_Y[di]	; Y
		sub dx,7		; Above the ground

		mov al,b cs:Cheap_Rand	;
		and ax,1
	mov ax,iEye		; Get the shape

		push di			; Save
		call Draw_Sprite	; Show it
		pop di			; Restore
		
		mov ax,iThgt0

		sub dx,22
		sub bx,9
		push di
		call Draw_Sprite	; Show it
		pop di

DE_X:		clc			; Ok
		ret			; Done/Not shown

; Calc where the player is relative to a thing

Calc_MTP_Vect:	mov cx,0		; Assume same

		mov dx,cs:d_X[di]	; Compare the X's
		sub dx,cs:Player_X	;
		je CMTPV_1		; Same, exit

		mov cx,-1		; Assume this way		
		ja CMTPV_1		; Yes, skip

		mov cx,1		; Wrong

CMTPV_1:	mov dx,cs:d_Y[di]	; Compare the Y's
		sub dx,cs:Player_Y	;
		je CMTPV_X		; Same, exit

		mov dx,-1		; Assume this way		
		ja CMTPV_X		; Yes, skip

		mov dx,1		; Wrong

CMTPV_X:	ret			; Done

; Can we move in X ?

Thing_Test_X:	mov ax,cs:ddX[di]	; Get the current dX
		cmp ax,0		; Any ?
		je TTX_X		; No, skip

		; Yes, +/- ?

		jns TTX_R		; Skip if moving right

		sub ax,8*256		; Left
		jmp s TTX_1		; Skip

TTX_R:		add ax,8*256		; Right

TTX_1:		mov bx,ax		; X-step
		mov al,ah		; Make 24-bit
		cbw			;

		add bl,cs:d_frac_X[di]	; 24-bit add

		mov bx,cs:d_X[di]	; Get the old X
		adc ax,bx		; Accumulate the X

		; Is this the same block ?

		xor bx,ax		; Get any different bits
		and bl,0F0h		; Different block ?
		je TTX_X		; No, exit

		; Different. Get a pointer to the appropriate block.

		mov bx,cs:d_Y[di]	; Get the Y
		sub bx,28		; Up

		; Get a pointer to this block

		push ax			; Save X
		push bx			; Y

		call Calc_pMap		; Point at this block
		mov si,ax		; Get it

		pop bx			; Restore Y
		pop ax			; X

		jc TTX_Solid		; Solid

		; Now, try down

		add bx,27		; Move down

		call Calc_pMap		; Point at this block
		jc TTX_Solid		; Solid

		mov bx,ax		; Save the ptr

		; Loop examining blocks until a solid one found

TTX_Lp:		test w cs:[si],0100h	; Solid ?
		jne TTX_Solid		; No, skip

		cmp si,bx		; Done ?
		je TTX_X		; Yes, skip

		add si,128*2		; Move down

		jmp s TTX_Lp		; Loop

	; Solid, return CF

TTX_Solid:	stc			; Solid
		ret			;

TTX_X:		clc			; Clear
		ret			;

; Can we move in Y ? (return ax = Y of the block we hit if failed)

Thing_Test_Y:	mov ax,cs:ddY[di]	; Which way are we going ?
		cmp ax,0		;
		js TTY_Up		; Up, ok

		; We are stat. / falling

		mov cx,ax		; Y-step
		mov al,ch		; Make 24-bit
		cbw			;

		add cl,cs:d_frac_Y[di]	; 24-bit add
		adc ax,cs:d_Y[di]	; Accumulate the Y

		mov bx,ax		; Get the Y
		mov dl,bl		; Save the offset into the block

		mov ax,cs:d_X[di]	; Get the X
		sub ax,5		; LHS

		mov cx,ax		; RHS
		add cx,9		;

Thing_C_Stand:	mov cs:PT_LHS,ax	; Save them
		mov cs:PT_RHS,cx	;
		mov cs:PT_Y,bx		;

		push di			; Save
		call Check_Floor	; Are we standing on anything ?
		pop di			;

		jnc TTY_Solid		; No, look for a platform

		ret			; Done

	; Going up, hit roof ?

TTY_Up:		mov ax,35		; Limit

		cmp ax,cs:d_Y[di]	; Giz the Y
		jb TT_Yes		; Yes, skip

		mov cs:d_Y[di],ax	; Clip it
		mov w cs:ddY[di],0	;

		; We can fall through this block

TT_Yes:		clc			; Yes
		ret			;

TT_No:		stc			; No
		ret			;

	; Are we on a platform ?

TTY_Solid:	push di			; Save

		lea di,ddY[di]		; Point at our dY (for springs)
		mov cs:TTY_pDY,di	; Save it

		mov di,o Solid_List	; Point at the list

TTYS_Lp:	mov ax,cs:4[di]		; Width
		cmp ax,0		; End ?
		je TTYS_X		; Yes, exit

		mov bx,cs:[di]		; Centre of platform
		sub bx,ax		; LHS

		cmp bx,cs:PT_RHS	; Overlap ?
		jae TTYS_Next		; No skip

		add bx,ax		; RHS
		add bx,ax		;

		cmp bx,cs:PT_LHS	; Overlap ?
		jb TTYS_Next		; No, skip

		; X is OK, what about the Y ?

		mov ax,cs:2[di]		; Get ze Y

		sub ax,3
		cmp ax,cs:PT_Y		; Above the platform ?
		ja TTYS_Next		; Yes, skip

		add ax,10+3		; Up to 10 below it ?
		cmp ax,cs:PT_Y		;
		jbe TTYS_Next		; No, skip

		; We are standing on this platform

		sub ax,10		; Return the Y

		mov b cs:TT_Plat_F,2	; Yes, we are on one

		; Point at the platform and flag that we are on it (Don't !)

		mov bx,cs:6[di]		; pPlat
		or w cs:dpFlags[bx],2	; Hit the flag

		mov cx,cs:TTY_pDY	    ; Point at our dY
		mov w cs:dppOccupier[bx],cx ;

		mov bx,cs:[di]		; Save the platform posn
		mov cs:PT_Plat_X,bx	;
		mov cs:PT_Plat_Y,ax	;

		stc			; Hit
		pop di			; Restore
		ret			; Done

TTYS_Next:	lea di,8[di]		; Skip this one
		jmp s TTYS_Lp		; Loop

TTYS_X:		clc			; No
		pop di			; Restore
		ret			; Done

; Vars

		align 2

pPrev_Thing	dw ?			; Used to remove things
pVisible	dw ?			; List head of visible things

TTY_pDY		dw ?			; Point at this things DY
TT_Plat_F	db ?			; NZ = standing on a platform
